Imports System.Runtime.InteropServices
Imports System.Windows.Forms
Imports System.Diagnostics
Imports System.Reflection

'Add-in Express Add-in Module
<GuidAttribute("CCFAE5A1-8933-4F67-B8D0-28E30B779BDF"), ProgIdAttribute("XLToys.AddinModule")> _
Public Class AddinModule
    Inherits AddinExpress.MSO.ADXAddinModule
    Friend WithEvents imageList16 As System.Windows.Forms.ImageList

    Private Const xlLinks As Integer = &HFF
    Private Const xlColumnWidths As Integer = 8
    Private Const xlDataValidation As Integer = 6

    Private Enum XldMergeCells
        mcTopDown
        mcTop
        mcBottom
        mcCenter
    End Enum

    Private Enum XldVAlignment
        vaTop
        vaCenter
        vaBottom
    End Enum

    Private Enum XldShowHide
        shZeros
        shComments
        shGridlines
        shFormulas
        shPageBreaks
    End Enum

    Private Enum XldCellFormat
        cfWrapText
        cfShrinkToFit
        cfUnderlineNone
        cfUnderlineSingle
        cfUnderlineDouble
        cfUnderlineSingleAccounting
        cfUnderlineDoubleAccounting
    End Enum

#Region " Component Designer generated code. "
    'Required by designer
    Private components As System.ComponentModel.IContainer

    'Required by designer - do not modify
    'the following method
    Friend WithEvents adxCommandBar1 As AddinExpress.MSO.ADXCommandBar
    Friend WithEvents btnAboutADXToys2 As AddinExpress.MSO.ADXCommandBarButton
    Friend WithEvents btnWrapText As AddinExpress.MSO.ADXCommandBarButton
    Friend WithEvents btnShrinkToFit As AddinExpress.MSO.ADXCommandBarButton
    Friend WithEvents ppUnderline As AddinExpress.MSO.ADXCommandBarPopup
    Friend WithEvents btnNone As AddinExpress.MSO.ADXCommandBarButton
    Friend WithEvents btnSingle As AddinExpress.MSO.ADXCommandBarButton
    Friend WithEvents btnDouble As AddinExpress.MSO.ADXCommandBarButton
    Friend WithEvents btnSingleAccounting As AddinExpress.MSO.ADXCommandBarButton
    Friend WithEvents btnDoubleAccounting As AddinExpress.MSO.ADXCommandBarButton
    Friend WithEvents btnAlignTop As AddinExpress.MSO.ADXCommandBarButton
    Friend WithEvents btnAlignCenter As AddinExpress.MSO.ADXCommandBarButton
    Friend WithEvents btnAlignBottom As AddinExpress.MSO.ADXCommandBarButton
    Friend WithEvents btnMergeCellsTopdown As AddinExpress.MSO.ADXCommandBarButton
    Friend WithEvents btnMergeAndTop As AddinExpress.MSO.ADXCommandBarButton
    Friend WithEvents btnMergeAndCenter As AddinExpress.MSO.ADXCommandBarButton
    Friend WithEvents btnMergeAndBottom As AddinExpress.MSO.ADXCommandBarButton
    Friend WithEvents ppShowHide As AddinExpress.MSO.ADXCommandBarPopup
    Friend WithEvents btnComments As AddinExpress.MSO.ADXCommandBarButton
    Friend WithEvents btnZeroValues As AddinExpress.MSO.ADXCommandBarButton
    Friend WithEvents btnFormulas As AddinExpress.MSO.ADXCommandBarButton
    Friend WithEvents btnGridlines As AddinExpress.MSO.ADXCommandBarButton
    Friend WithEvents btnPageBreaks As AddinExpress.MSO.ADXCommandBarButton
    Friend WithEvents ppPasteSpecial As AddinExpress.MSO.ADXCommandBarPopup
    Friend WithEvents btnAll As AddinExpress.MSO.ADXCommandBarButton
    Friend WithEvents btnAllExceptBorders As AddinExpress.MSO.ADXCommandBarButton
    Friend WithEvents btnPasteLinks As AddinExpress.MSO.ADXCommandBarButton
    Friend WithEvents btnFormulas_pp As AddinExpress.MSO.ADXCommandBarButton
    Friend WithEvents btnValues As AddinExpress.MSO.ADXCommandBarButton
    Friend WithEvents btnFormats As AddinExpress.MSO.ADXCommandBarButton
    Friend WithEvents btnComments_pp As AddinExpress.MSO.ADXCommandBarButton
    Friend WithEvents btnColumnWidths As AddinExpress.MSO.ADXCommandBarButton
    Friend WithEvents btnDataValidation As AddinExpress.MSO.ADXCommandBarButton
    Friend WithEvents btnPasteNone As AddinExpress.MSO.ADXCommandBarButton
    Friend WithEvents btnPasteAdd As AddinExpress.MSO.ADXCommandBarButton
    Friend WithEvents btnPasteSubtract As AddinExpress.MSO.ADXCommandBarButton
    Friend WithEvents btnPasteMultiply As AddinExpress.MSO.ADXCommandBarButton
    Friend WithEvents btnPasteDivide As AddinExpress.MSO.ADXCommandBarButton
    Friend WithEvents btnSkipBlanks As AddinExpress.MSO.ADXCommandBarButton
    Friend WithEvents AdxRibbonTab As AddinExpress.MSO.ADXRibbonTab
    Friend WithEvents RibbonGroup As AddinExpress.MSO.ADXRibbonGroup
    Friend WithEvents ImageList32 As System.Windows.Forms.ImageList
    Friend WithEvents RibbonButtonAbout As AddinExpress.MSO.ADXRibbonButton
    Friend WithEvents RibbonSeparator1 As AddinExpress.MSO.ADXRibbonSeparator
    Friend WithEvents RibbonButtonWrapText As AddinExpress.MSO.ADXRibbonButton
    Friend WithEvents RibbonButtonShrinkToFit As AddinExpress.MSO.ADXRibbonButton
    Friend WithEvents RibbonGalleryUnderline As AddinExpress.MSO.ADXRibbonGallery
    Friend WithEvents RibbonButtonNone As AddinExpress.MSO.ADXRibbonButton
    Friend WithEvents RibbonButtonSingle As AddinExpress.MSO.ADXRibbonButton
    Friend WithEvents RibbonButtonDouble As AddinExpress.MSO.ADXRibbonButton
    Friend WithEvents RibbonButtonSingleAccounting As AddinExpress.MSO.ADXRibbonButton
    Friend WithEvents RibbonButtonDoubleAccounting As AddinExpress.MSO.ADXRibbonButton
    Friend WithEvents RibbonButtonGroup1 As AddinExpress.MSO.ADXRibbonButtonGroup
    Friend WithEvents RibbonSeparator2 As AddinExpress.MSO.ADXRibbonSeparator
    Friend WithEvents RibbonButtonAlignTop As AddinExpress.MSO.ADXRibbonButton
    Friend WithEvents RibbonButtonAlignCenter As AddinExpress.MSO.ADXRibbonButton
    Friend WithEvents RibbonButtonAlignBottom As AddinExpress.MSO.ADXRibbonButton
    Friend WithEvents RibbonSeparator3 As AddinExpress.MSO.ADXRibbonSeparator
    Friend WithEvents RibbonButtonMergeCellsTopDown As AddinExpress.MSO.ADXRibbonButton
    Friend WithEvents RibbonButtonMergeTop As AddinExpress.MSO.ADXRibbonButton
    Friend WithEvents RibbonButtonMergeCenter As AddinExpress.MSO.ADXRibbonButton
    Friend WithEvents RibbonButtonMergeBottom As AddinExpress.MSO.ADXRibbonButton
    Friend WithEvents RibbonButtonGroup2 As AddinExpress.MSO.ADXRibbonButtonGroup
    Friend WithEvents RibbonMenuPasteSpecial As AddinExpress.MSO.ADXRibbonMenu
    Friend WithEvents RibbonButtonAll As AddinExpress.MSO.ADXRibbonButton
    Friend WithEvents RibbonButtonAllExceptBorders As AddinExpress.MSO.ADXRibbonButton
    Friend WithEvents RibbonButtonPasteLinks As AddinExpress.MSO.ADXRibbonButton
    Friend WithEvents RibbonButtonFormulas As AddinExpress.MSO.ADXRibbonButton
    Friend WithEvents RibbonButtonValues As AddinExpress.MSO.ADXRibbonButton
    Friend WithEvents RibbonButtonFormats As AddinExpress.MSO.ADXRibbonButton
    Friend WithEvents RibbonButtonComments As AddinExpress.MSO.ADXRibbonButton
    Friend WithEvents RibbonButtonColumnWidths As AddinExpress.MSO.ADXRibbonButton
    Friend WithEvents RibbonButtonDataValidation As AddinExpress.MSO.ADXRibbonButton
    Friend WithEvents RibbonButtonPasteNone As AddinExpress.MSO.ADXRibbonButton
    Friend WithEvents RibbonButtonPasteAdd As AddinExpress.MSO.ADXRibbonButton
    Friend WithEvents RibbonButtonPasteSubtract As AddinExpress.MSO.ADXRibbonButton
    Friend WithEvents RibbonButtonPasteMultiply As AddinExpress.MSO.ADXRibbonButton
    Friend WithEvents RibbonButtonPasteDivide As AddinExpress.MSO.ADXRibbonButton
    Friend WithEvents RibbonButtonSkipBlanks As AddinExpress.MSO.ADXRibbonButton
    Friend WithEvents RibbonButtonTranspose As AddinExpress.MSO.ADXRibbonButton
    Friend WithEvents RibbonMenuSeparator1 As AddinExpress.MSO.ADXRibbonMenuSeparator
    Friend WithEvents RibbonGalleryShowHide As AddinExpress.MSO.ADXRibbonGallery
    Friend WithEvents RibbonButtonShowHideComments As AddinExpress.MSO.ADXRibbonButton
    Friend WithEvents RibbonButtonShowHideZeroValues As AddinExpress.MSO.ADXRibbonButton
    Friend WithEvents RibbonButtonShowHideFormulas As AddinExpress.MSO.ADXRibbonButton
    Friend WithEvents RibbonButtonShowHideGridlines As AddinExpress.MSO.ADXRibbonButton
    Friend WithEvents RibbonButtonShowHidePageBreaks As AddinExpress.MSO.ADXRibbonButton
    Friend WithEvents RibbonSeparator4 As AddinExpress.MSO.ADXRibbonSeparator
    Friend WithEvents btnTranspose As AddinExpress.MSO.ADXCommandBarButton
    Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container()
        Dim resources As System.ComponentModel.ComponentResourceManager = New System.ComponentModel.ComponentResourceManager(GetType(AddinModule))
        Me.imageList16 = New System.Windows.Forms.ImageList(Me.components)
        Me.adxCommandBar1 = New AddinExpress.MSO.ADXCommandBar(Me.components)
        Me.btnAboutADXToys2 = New AddinExpress.MSO.ADXCommandBarButton(Me.components)
        Me.btnWrapText = New AddinExpress.MSO.ADXCommandBarButton(Me.components)
        Me.btnShrinkToFit = New AddinExpress.MSO.ADXCommandBarButton(Me.components)
        Me.ppUnderline = New AddinExpress.MSO.ADXCommandBarPopup(Me.components)
        Me.btnNone = New AddinExpress.MSO.ADXCommandBarButton(Me.components)
        Me.btnSingle = New AddinExpress.MSO.ADXCommandBarButton(Me.components)
        Me.btnDouble = New AddinExpress.MSO.ADXCommandBarButton(Me.components)
        Me.btnSingleAccounting = New AddinExpress.MSO.ADXCommandBarButton(Me.components)
        Me.btnDoubleAccounting = New AddinExpress.MSO.ADXCommandBarButton(Me.components)
        Me.btnAlignTop = New AddinExpress.MSO.ADXCommandBarButton(Me.components)
        Me.btnAlignCenter = New AddinExpress.MSO.ADXCommandBarButton(Me.components)
        Me.btnAlignBottom = New AddinExpress.MSO.ADXCommandBarButton(Me.components)
        Me.btnMergeCellsTopdown = New AddinExpress.MSO.ADXCommandBarButton(Me.components)
        Me.btnMergeAndTop = New AddinExpress.MSO.ADXCommandBarButton(Me.components)
        Me.btnMergeAndCenter = New AddinExpress.MSO.ADXCommandBarButton(Me.components)
        Me.btnMergeAndBottom = New AddinExpress.MSO.ADXCommandBarButton(Me.components)
        Me.ppShowHide = New AddinExpress.MSO.ADXCommandBarPopup(Me.components)
        Me.btnComments = New AddinExpress.MSO.ADXCommandBarButton(Me.components)
        Me.btnZeroValues = New AddinExpress.MSO.ADXCommandBarButton(Me.components)
        Me.btnFormulas = New AddinExpress.MSO.ADXCommandBarButton(Me.components)
        Me.btnGridlines = New AddinExpress.MSO.ADXCommandBarButton(Me.components)
        Me.btnPageBreaks = New AddinExpress.MSO.ADXCommandBarButton(Me.components)
        Me.ppPasteSpecial = New AddinExpress.MSO.ADXCommandBarPopup(Me.components)
        Me.btnAll = New AddinExpress.MSO.ADXCommandBarButton(Me.components)
        Me.btnAllExceptBorders = New AddinExpress.MSO.ADXCommandBarButton(Me.components)
        Me.btnPasteLinks = New AddinExpress.MSO.ADXCommandBarButton(Me.components)
        Me.btnFormulas_pp = New AddinExpress.MSO.ADXCommandBarButton(Me.components)
        Me.btnValues = New AddinExpress.MSO.ADXCommandBarButton(Me.components)
        Me.btnFormats = New AddinExpress.MSO.ADXCommandBarButton(Me.components)
        Me.btnComments_pp = New AddinExpress.MSO.ADXCommandBarButton(Me.components)
        Me.btnColumnWidths = New AddinExpress.MSO.ADXCommandBarButton(Me.components)
        Me.btnDataValidation = New AddinExpress.MSO.ADXCommandBarButton(Me.components)
        Me.btnPasteNone = New AddinExpress.MSO.ADXCommandBarButton(Me.components)
        Me.btnPasteAdd = New AddinExpress.MSO.ADXCommandBarButton(Me.components)
        Me.btnPasteSubtract = New AddinExpress.MSO.ADXCommandBarButton(Me.components)
        Me.btnPasteMultiply = New AddinExpress.MSO.ADXCommandBarButton(Me.components)
        Me.btnPasteDivide = New AddinExpress.MSO.ADXCommandBarButton(Me.components)
        Me.btnSkipBlanks = New AddinExpress.MSO.ADXCommandBarButton(Me.components)
        Me.btnTranspose = New AddinExpress.MSO.ADXCommandBarButton(Me.components)
        Me.AdxRibbonTab = New AddinExpress.MSO.ADXRibbonTab(Me.components)
        Me.RibbonGroup = New AddinExpress.MSO.ADXRibbonGroup(Me.components)
        Me.RibbonButtonAbout = New AddinExpress.MSO.ADXRibbonButton(Me.components)
        Me.ImageList32 = New System.Windows.Forms.ImageList(Me.components)
        Me.RibbonSeparator1 = New AddinExpress.MSO.ADXRibbonSeparator(Me.components)
        Me.RibbonButtonGroup1 = New AddinExpress.MSO.ADXRibbonButtonGroup(Me.components)
        Me.RibbonButtonWrapText = New AddinExpress.MSO.ADXRibbonButton(Me.components)
        Me.RibbonButtonShrinkToFit = New AddinExpress.MSO.ADXRibbonButton(Me.components)
        Me.RibbonGalleryUnderline = New AddinExpress.MSO.ADXRibbonGallery(Me.components)
        Me.RibbonButtonNone = New AddinExpress.MSO.ADXRibbonButton(Me.components)
        Me.RibbonButtonSingle = New AddinExpress.MSO.ADXRibbonButton(Me.components)
        Me.RibbonButtonDouble = New AddinExpress.MSO.ADXRibbonButton(Me.components)
        Me.RibbonButtonSingleAccounting = New AddinExpress.MSO.ADXRibbonButton(Me.components)
        Me.RibbonButtonDoubleAccounting = New AddinExpress.MSO.ADXRibbonButton(Me.components)
        Me.RibbonSeparator2 = New AddinExpress.MSO.ADXRibbonSeparator(Me.components)
        Me.RibbonButtonAlignTop = New AddinExpress.MSO.ADXRibbonButton(Me.components)
        Me.RibbonButtonAlignCenter = New AddinExpress.MSO.ADXRibbonButton(Me.components)
        Me.RibbonButtonAlignBottom = New AddinExpress.MSO.ADXRibbonButton(Me.components)
        Me.RibbonSeparator3 = New AddinExpress.MSO.ADXRibbonSeparator(Me.components)
        Me.RibbonButtonMergeCellsTopDown = New AddinExpress.MSO.ADXRibbonButton(Me.components)
        Me.RibbonButtonMergeTop = New AddinExpress.MSO.ADXRibbonButton(Me.components)
        Me.RibbonButtonMergeCenter = New AddinExpress.MSO.ADXRibbonButton(Me.components)
        Me.RibbonButtonMergeBottom = New AddinExpress.MSO.ADXRibbonButton(Me.components)
        Me.RibbonButtonGroup2 = New AddinExpress.MSO.ADXRibbonButtonGroup(Me.components)
        Me.RibbonGalleryShowHide = New AddinExpress.MSO.ADXRibbonGallery(Me.components)
        Me.RibbonButtonShowHideComments = New AddinExpress.MSO.ADXRibbonButton(Me.components)
        Me.RibbonButtonShowHideZeroValues = New AddinExpress.MSO.ADXRibbonButton(Me.components)
        Me.RibbonButtonShowHideFormulas = New AddinExpress.MSO.ADXRibbonButton(Me.components)
        Me.RibbonButtonShowHideGridlines = New AddinExpress.MSO.ADXRibbonButton(Me.components)
        Me.RibbonButtonShowHidePageBreaks = New AddinExpress.MSO.ADXRibbonButton(Me.components)
        Me.RibbonSeparator4 = New AddinExpress.MSO.ADXRibbonSeparator(Me.components)
        Me.RibbonMenuPasteSpecial = New AddinExpress.MSO.ADXRibbonMenu(Me.components)
        Me.RibbonButtonAll = New AddinExpress.MSO.ADXRibbonButton(Me.components)
        Me.RibbonButtonAllExceptBorders = New AddinExpress.MSO.ADXRibbonButton(Me.components)
        Me.RibbonButtonPasteLinks = New AddinExpress.MSO.ADXRibbonButton(Me.components)
        Me.RibbonMenuSeparator1 = New AddinExpress.MSO.ADXRibbonMenuSeparator(Me.components)
        Me.RibbonButtonFormulas = New AddinExpress.MSO.ADXRibbonButton(Me.components)
        Me.RibbonButtonValues = New AddinExpress.MSO.ADXRibbonButton(Me.components)
        Me.RibbonButtonFormats = New AddinExpress.MSO.ADXRibbonButton(Me.components)
        Me.RibbonButtonComments = New AddinExpress.MSO.ADXRibbonButton(Me.components)
        Me.RibbonButtonColumnWidths = New AddinExpress.MSO.ADXRibbonButton(Me.components)
        Me.RibbonButtonDataValidation = New AddinExpress.MSO.ADXRibbonButton(Me.components)
        Me.RibbonButtonPasteNone = New AddinExpress.MSO.ADXRibbonButton(Me.components)
        Me.RibbonButtonPasteAdd = New AddinExpress.MSO.ADXRibbonButton(Me.components)
        Me.RibbonButtonPasteSubtract = New AddinExpress.MSO.ADXRibbonButton(Me.components)
        Me.RibbonButtonPasteMultiply = New AddinExpress.MSO.ADXRibbonButton(Me.components)
        Me.RibbonButtonPasteDivide = New AddinExpress.MSO.ADXRibbonButton(Me.components)
        Me.RibbonButtonSkipBlanks = New AddinExpress.MSO.ADXRibbonButton(Me.components)
        Me.RibbonButtonTranspose = New AddinExpress.MSO.ADXRibbonButton(Me.components)
        '
        'imageList16
        '
        Me.imageList16.ImageStream = CType(resources.GetObject("imageList16.ImageStream"), System.Windows.Forms.ImageListStreamer)
        Me.imageList16.TransparentColor = System.Drawing.Color.Transparent
        Me.imageList16.Images.SetKeyName(0, "")
        Me.imageList16.Images.SetKeyName(1, "")
        Me.imageList16.Images.SetKeyName(2, "")
        Me.imageList16.Images.SetKeyName(3, "")
        Me.imageList16.Images.SetKeyName(4, "")
        Me.imageList16.Images.SetKeyName(5, "")
        Me.imageList16.Images.SetKeyName(6, "")
        Me.imageList16.Images.SetKeyName(7, "")
        Me.imageList16.Images.SetKeyName(8, "")
        Me.imageList16.Images.SetKeyName(9, "")
        Me.imageList16.Images.SetKeyName(10, "")
        Me.imageList16.Images.SetKeyName(11, "")
        Me.imageList16.Images.SetKeyName(12, "")
        Me.imageList16.Images.SetKeyName(13, "")
        Me.imageList16.Images.SetKeyName(14, "")
        Me.imageList16.Images.SetKeyName(15, "")
        Me.imageList16.Images.SetKeyName(16, "")
        Me.imageList16.Images.SetKeyName(17, "")
        Me.imageList16.Images.SetKeyName(18, "")
        Me.imageList16.Images.SetKeyName(19, "")
        Me.imageList16.Images.SetKeyName(20, "")
        Me.imageList16.Images.SetKeyName(21, "")
        Me.imageList16.Images.SetKeyName(22, "")
        Me.imageList16.Images.SetKeyName(23, "")
        Me.imageList16.Images.SetKeyName(24, "")
        Me.imageList16.Images.SetKeyName(25, "")
        Me.imageList16.Images.SetKeyName(26, "")
        Me.imageList16.Images.SetKeyName(27, "")
        Me.imageList16.Images.SetKeyName(28, "")
        Me.imageList16.Images.SetKeyName(29, "")
        Me.imageList16.Images.SetKeyName(30, "")
        Me.imageList16.Images.SetKeyName(31, "")
        '
        'adxCommandBar1
        '
        Me.adxCommandBar1.CommandBarName = "Add-in Express Toys for Excel (VB.NET)"
        Me.adxCommandBar1.CommandBarTag = "8e4ff8df-2005-4ece-bc89-aa732f19ce99"
        Me.adxCommandBar1.Controls.Add(Me.btnAboutADXToys2)
        Me.adxCommandBar1.Controls.Add(Me.btnWrapText)
        Me.adxCommandBar1.Controls.Add(Me.btnShrinkToFit)
        Me.adxCommandBar1.Controls.Add(Me.ppUnderline)
        Me.adxCommandBar1.Controls.Add(Me.btnAlignTop)
        Me.adxCommandBar1.Controls.Add(Me.btnAlignCenter)
        Me.adxCommandBar1.Controls.Add(Me.btnAlignBottom)
        Me.adxCommandBar1.Controls.Add(Me.btnMergeCellsTopdown)
        Me.adxCommandBar1.Controls.Add(Me.btnMergeAndTop)
        Me.adxCommandBar1.Controls.Add(Me.btnMergeAndCenter)
        Me.adxCommandBar1.Controls.Add(Me.btnMergeAndBottom)
        Me.adxCommandBar1.Controls.Add(Me.ppShowHide)
        Me.adxCommandBar1.Controls.Add(Me.ppPasteSpecial)
        Me.adxCommandBar1.Controls.Add(Me.btnPasteNone)
        Me.adxCommandBar1.Controls.Add(Me.btnPasteAdd)
        Me.adxCommandBar1.Controls.Add(Me.btnPasteSubtract)
        Me.adxCommandBar1.Controls.Add(Me.btnPasteMultiply)
        Me.adxCommandBar1.Controls.Add(Me.btnPasteDivide)
        Me.adxCommandBar1.Controls.Add(Me.btnSkipBlanks)
        Me.adxCommandBar1.Controls.Add(Me.btnTranspose)
        Me.adxCommandBar1.UpdateCounter = 29
        '
        'btnAboutADXToys2
        '
        Me.btnAboutADXToys2.Caption = "About ADX Toys 2"
        Me.btnAboutADXToys2.ControlTag = "f921bf69-f12c-4e28-92b0-1c4aff94401c"
        Me.btnAboutADXToys2.Image = 0
        Me.btnAboutADXToys2.ImageTransparentColor = System.Drawing.Color.Transparent
        Me.btnAboutADXToys2.Style = AddinExpress.MSO.ADXMsoButtonStyle.adxMsoButtonIcon
        Me.btnAboutADXToys2.Tag = "10"
        Me.btnAboutADXToys2.UpdateCounter = 14
        '
        'btnWrapText
        '
        Me.btnWrapText.BeginGroup = True
        Me.btnWrapText.Caption = "Wrap Text"
        Me.btnWrapText.ControlTag = "e59cfd4d-77c5-46b1-9d24-3135c9f11c57"
        Me.btnWrapText.Image = 3
        Me.btnWrapText.ImageTransparentColor = System.Drawing.Color.Cyan
        Me.btnWrapText.Style = AddinExpress.MSO.ADXMsoButtonStyle.adxMsoButtonIcon
        Me.btnWrapText.Tag = "51"
        Me.btnWrapText.UpdateCounter = 6
        '
        'btnShrinkToFit
        '
        Me.btnShrinkToFit.Caption = "Shrink To Fit"
        Me.btnShrinkToFit.ControlTag = "559a127b-644a-4ae0-9908-45dc21f55ec4"
        Me.btnShrinkToFit.Image = 28
        Me.btnShrinkToFit.ImageTransparentColor = System.Drawing.Color.Cyan
        Me.btnShrinkToFit.Style = AddinExpress.MSO.ADXMsoButtonStyle.adxMsoButtonIcon
        Me.btnShrinkToFit.Tag = "52"
        Me.btnShrinkToFit.UpdateCounter = 6
        '
        'ppUnderline
        '
        Me.ppUnderline.Caption = "Underline"
        Me.ppUnderline.Controls.Add(Me.btnNone)
        Me.ppUnderline.Controls.Add(Me.btnSingle)
        Me.ppUnderline.Controls.Add(Me.btnDouble)
        Me.ppUnderline.Controls.Add(Me.btnSingleAccounting)
        Me.ppUnderline.Controls.Add(Me.btnDoubleAccounting)
        Me.ppUnderline.ControlTag = "470c32c3-9de2-4ea9-9e28-efb90212ec9d"
        Me.ppUnderline.DescriptionText = "Underline"
        Me.ppUnderline.UpdateCounter = 5
        '
        'btnNone
        '
        Me.btnNone.Caption = "None"
        Me.btnNone.ControlTag = "a0055817-8545-43d6-8b69-2738633419c5"
        Me.btnNone.Image = 22
        Me.btnNone.ImageTransparentColor = System.Drawing.Color.Cyan
        Me.btnNone.Style = AddinExpress.MSO.ADXMsoButtonStyle.adxMsoButtonAutomatic
        Me.btnNone.Tag = "53"
        Me.btnNone.UpdateCounter = 9
        '
        'btnSingle
        '
        Me.btnSingle.Caption = "Single"
        Me.btnSingle.ControlTag = "987d5ec7-d0db-4d40-8238-a8c0d2484f89"
        Me.btnSingle.Image = 23
        Me.btnSingle.ImageTransparentColor = System.Drawing.Color.Cyan
        Me.btnSingle.Style = AddinExpress.MSO.ADXMsoButtonStyle.adxMsoButtonAutomatic
        Me.btnSingle.Tag = "54"
        Me.btnSingle.UpdateCounter = 10
        '
        'btnDouble
        '
        Me.btnDouble.Caption = "Double"
        Me.btnDouble.ControlTag = "bf62cd96-82c1-45e7-b9e7-f1df0b42c203"
        Me.btnDouble.Image = 20
        Me.btnDouble.ImageTransparentColor = System.Drawing.Color.Cyan
        Me.btnDouble.Style = AddinExpress.MSO.ADXMsoButtonStyle.adxMsoButtonAutomatic
        Me.btnDouble.Tag = "55"
        Me.btnDouble.UpdateCounter = 6
        '
        'btnSingleAccounting
        '
        Me.btnSingleAccounting.Caption = "Single Accounting"
        Me.btnSingleAccounting.ControlTag = "45e32ba5-2e05-4812-a947-a7360f7db80d"
        Me.btnSingleAccounting.Image = 24
        Me.btnSingleAccounting.ImageTransparentColor = System.Drawing.Color.Cyan
        Me.btnSingleAccounting.Style = AddinExpress.MSO.ADXMsoButtonStyle.adxMsoButtonAutomatic
        Me.btnSingleAccounting.Tag = "56"
        Me.btnSingleAccounting.UpdateCounter = 6
        '
        'btnDoubleAccounting
        '
        Me.btnDoubleAccounting.Caption = "Double Accounting"
        Me.btnDoubleAccounting.ControlTag = "50350dab-5081-4957-8c32-5df4e151ebdf"
        Me.btnDoubleAccounting.Image = 21
        Me.btnDoubleAccounting.ImageTransparentColor = System.Drawing.Color.Cyan
        Me.btnDoubleAccounting.Style = AddinExpress.MSO.ADXMsoButtonStyle.adxMsoButtonAutomatic
        Me.btnDoubleAccounting.Tag = "57"
        Me.btnDoubleAccounting.UpdateCounter = 8
        '
        'btnAlignTop
        '
        Me.btnAlignTop.BeginGroup = True
        Me.btnAlignTop.Caption = "Align Top"
        Me.btnAlignTop.ControlTag = "1ae63fc4-8669-4d0c-90dc-07b57b7ca6c8"
        Me.btnAlignTop.Image = 31
        Me.btnAlignTop.ImageTransparentColor = System.Drawing.Color.Cyan
        Me.btnAlignTop.Style = AddinExpress.MSO.ADXMsoButtonStyle.adxMsoButtonIcon
        Me.btnAlignTop.Tag = "20"
        Me.btnAlignTop.UpdateCounter = 7
        '
        'btnAlignCenter
        '
        Me.btnAlignCenter.Caption = "Align Center"
        Me.btnAlignCenter.ControlTag = "c95b8a71-1713-4a35-a291-81203cf3f5d9"
        Me.btnAlignCenter.Image = 2
        Me.btnAlignCenter.ImageTransparentColor = System.Drawing.Color.Cyan
        Me.btnAlignCenter.Style = AddinExpress.MSO.ADXMsoButtonStyle.adxMsoButtonIcon
        Me.btnAlignCenter.Tag = "21"
        Me.btnAlignCenter.UpdateCounter = 5
        '
        'btnAlignBottom
        '
        Me.btnAlignBottom.Caption = "Align Bottom"
        Me.btnAlignBottom.ControlTag = "d6a5dc02-4978-4e6b-873f-d7bb1302ba87"
        Me.btnAlignBottom.Image = 1
        Me.btnAlignBottom.ImageTransparentColor = System.Drawing.Color.Cyan
        Me.btnAlignBottom.Style = AddinExpress.MSO.ADXMsoButtonStyle.adxMsoButtonIcon
        Me.btnAlignBottom.Tag = "22"
        Me.btnAlignBottom.UpdateCounter = 5
        '
        'btnMergeCellsTopdown
        '
        Me.btnMergeCellsTopdown.BeginGroup = True
        Me.btnMergeCellsTopdown.Caption = "Merge Cells Top-down"
        Me.btnMergeCellsTopdown.ControlTag = "301783cd-02e4-4b2c-850b-192d6ab864e5"
        Me.btnMergeCellsTopdown.Image = 4
        Me.btnMergeCellsTopdown.ImageTransparentColor = System.Drawing.Color.Cyan
        Me.btnMergeCellsTopdown.Style = AddinExpress.MSO.ADXMsoButtonStyle.adxMsoButtonIcon
        Me.btnMergeCellsTopdown.Tag = "30"
        Me.btnMergeCellsTopdown.UpdateCounter = 6
        '
        'btnMergeAndTop
        '
        Me.btnMergeAndTop.Caption = "Merge and Top"
        Me.btnMergeAndTop.ControlTag = "e0c37179-3e53-40dd-ae85-f85183e004ff"
        Me.btnMergeAndTop.Image = 7
        Me.btnMergeAndTop.ImageTransparentColor = System.Drawing.Color.Cyan
        Me.btnMergeAndTop.Style = AddinExpress.MSO.ADXMsoButtonStyle.adxMsoButtonIcon
        Me.btnMergeAndTop.Tag = "31"
        Me.btnMergeAndTop.UpdateCounter = 5
        '
        'btnMergeAndCenter
        '
        Me.btnMergeAndCenter.Caption = "Merge and Center"
        Me.btnMergeAndCenter.ControlTag = "bbd4bf9c-d7ba-43f6-b370-be375c65263b"
        Me.btnMergeAndCenter.Image = 6
        Me.btnMergeAndCenter.ImageTransparentColor = System.Drawing.Color.Cyan
        Me.btnMergeAndCenter.Style = AddinExpress.MSO.ADXMsoButtonStyle.adxMsoButtonIcon
        Me.btnMergeAndCenter.Tag = "32"
        Me.btnMergeAndCenter.UpdateCounter = 5
        '
        'btnMergeAndBottom
        '
        Me.btnMergeAndBottom.Caption = "Merge and Bottom"
        Me.btnMergeAndBottom.ControlTag = "38ff9336-41d2-4fa8-8285-8c485017162a"
        Me.btnMergeAndBottom.Image = 5
        Me.btnMergeAndBottom.ImageTransparentColor = System.Drawing.Color.Cyan
        Me.btnMergeAndBottom.Style = AddinExpress.MSO.ADXMsoButtonStyle.adxMsoButtonIcon
        Me.btnMergeAndBottom.Tag = "33"
        Me.btnMergeAndBottom.UpdateCounter = 5
        '
        'ppShowHide
        '
        Me.ppShowHide.BeginGroup = True
        Me.ppShowHide.Caption = "Show/Hide"
        Me.ppShowHide.Controls.Add(Me.btnComments)
        Me.ppShowHide.Controls.Add(Me.btnZeroValues)
        Me.ppShowHide.Controls.Add(Me.btnFormulas)
        Me.ppShowHide.Controls.Add(Me.btnGridlines)
        Me.ppShowHide.Controls.Add(Me.btnPageBreaks)
        Me.ppShowHide.ControlTag = "f0a81aa0-f08c-4ecf-89e3-af8ee4eef0a6"
        Me.ppShowHide.UpdateCounter = 2
        '
        'btnComments
        '
        Me.btnComments.Caption = "Comments"
        Me.btnComments.ControlTag = "edf34905-acf5-49ad-9e9c-df61f34ad3fc"
        Me.btnComments.Image = 15
        Me.btnComments.ImageTransparentColor = System.Drawing.Color.Cyan
        Me.btnComments.Style = AddinExpress.MSO.ADXMsoButtonStyle.adxMsoButtonAutomatic
        Me.btnComments.Tag = "41"
        Me.btnComments.UpdateCounter = 8
        '
        'btnZeroValues
        '
        Me.btnZeroValues.Caption = "Zero Values"
        Me.btnZeroValues.ControlTag = "11d8380d-70b9-458f-8ec2-c1d67cb592d5"
        Me.btnZeroValues.Image = 19
        Me.btnZeroValues.ImageTransparentColor = System.Drawing.Color.Cyan
        Me.btnZeroValues.Style = AddinExpress.MSO.ADXMsoButtonStyle.adxMsoButtonAutomatic
        Me.btnZeroValues.Tag = "42"
        Me.btnZeroValues.UpdateCounter = 6
        '
        'btnFormulas
        '
        Me.btnFormulas.Caption = "Formulas"
        Me.btnFormulas.ControlTag = "2de4fa7b-434d-4941-8400-4dd5e51374bb"
        Me.btnFormulas.Image = 16
        Me.btnFormulas.ImageTransparentColor = System.Drawing.Color.Cyan
        Me.btnFormulas.Style = AddinExpress.MSO.ADXMsoButtonStyle.adxMsoButtonAutomatic
        Me.btnFormulas.Tag = "43"
        Me.btnFormulas.UpdateCounter = 6
        '
        'btnGridlines
        '
        Me.btnGridlines.Caption = "Gridlines"
        Me.btnGridlines.ControlTag = "5b3f4a7a-d939-47e7-9cf3-f59faf23e8a1"
        Me.btnGridlines.Image = 17
        Me.btnGridlines.ImageTransparentColor = System.Drawing.Color.Cyan
        Me.btnGridlines.Style = AddinExpress.MSO.ADXMsoButtonStyle.adxMsoButtonAutomatic
        Me.btnGridlines.Tag = "44"
        Me.btnGridlines.UpdateCounter = 6
        '
        'btnPageBreaks
        '
        Me.btnPageBreaks.Caption = "Page Breaks"
        Me.btnPageBreaks.ControlTag = "18584715-62b1-4d4c-9478-235f546bf085"
        Me.btnPageBreaks.Image = 18
        Me.btnPageBreaks.ImageTransparentColor = System.Drawing.Color.Cyan
        Me.btnPageBreaks.Style = AddinExpress.MSO.ADXMsoButtonStyle.adxMsoButtonAutomatic
        Me.btnPageBreaks.Tag = "45"
        Me.btnPageBreaks.UpdateCounter = 6
        '
        'ppPasteSpecial
        '
        Me.ppPasteSpecial.BeginGroup = True
        Me.ppPasteSpecial.Caption = "Paste Special"
        Me.ppPasteSpecial.Controls.Add(Me.btnAll)
        Me.ppPasteSpecial.Controls.Add(Me.btnAllExceptBorders)
        Me.ppPasteSpecial.Controls.Add(Me.btnPasteLinks)
        Me.ppPasteSpecial.Controls.Add(Me.btnFormulas_pp)
        Me.ppPasteSpecial.Controls.Add(Me.btnValues)
        Me.ppPasteSpecial.Controls.Add(Me.btnFormats)
        Me.ppPasteSpecial.Controls.Add(Me.btnComments_pp)
        Me.ppPasteSpecial.Controls.Add(Me.btnColumnWidths)
        Me.ppPasteSpecial.Controls.Add(Me.btnDataValidation)
        Me.ppPasteSpecial.ControlTag = "d087da95-71e0-4049-8a03-61358f12dfc0"
        Me.ppPasteSpecial.UpdateCounter = 2
        '
        'btnAll
        '
        Me.btnAll.Caption = "All"
        Me.btnAll.ControlTag = "a649ea2a-38b8-44a8-949b-1df2eca94fc0"
        Me.btnAll.ImageTransparentColor = System.Drawing.Color.Transparent
        Me.btnAll.Style = AddinExpress.MSO.ADXMsoButtonStyle.adxMsoButtonAutomatic
        Me.btnAll.Tag = "61"
        Me.btnAll.UpdateCounter = 7
        '
        'btnAllExceptBorders
        '
        Me.btnAllExceptBorders.Caption = "All Except Borders"
        Me.btnAllExceptBorders.ControlTag = "0e549a1a-1f58-4f36-9df7-cd5bcfdddedd"
        Me.btnAllExceptBorders.ImageTransparentColor = System.Drawing.Color.Transparent
        Me.btnAllExceptBorders.Style = AddinExpress.MSO.ADXMsoButtonStyle.adxMsoButtonAutomatic
        Me.btnAllExceptBorders.Tag = "62"
        Me.btnAllExceptBorders.UpdateCounter = 5
        '
        'btnPasteLinks
        '
        Me.btnPasteLinks.Caption = "Paste Links"
        Me.btnPasteLinks.ControlTag = "dd1e2bdf-6b73-4562-ba86-59bb61e5a2e6"
        Me.btnPasteLinks.ImageTransparentColor = System.Drawing.Color.Transparent
        Me.btnPasteLinks.Style = AddinExpress.MSO.ADXMsoButtonStyle.adxMsoButtonAutomatic
        Me.btnPasteLinks.Tag = "63"
        Me.btnPasteLinks.UpdateCounter = 6
        '
        'btnFormulas_pp
        '
        Me.btnFormulas_pp.BeginGroup = True
        Me.btnFormulas_pp.Caption = "Formulas"
        Me.btnFormulas_pp.ControlTag = "9dbae657-416d-4046-a477-1cc98f260971"
        Me.btnFormulas_pp.ImageTransparentColor = System.Drawing.Color.Transparent
        Me.btnFormulas_pp.Style = AddinExpress.MSO.ADXMsoButtonStyle.adxMsoButtonAutomatic
        Me.btnFormulas_pp.Tag = "64"
        Me.btnFormulas_pp.UpdateCounter = 6
        '
        'btnValues
        '
        Me.btnValues.Caption = "Values"
        Me.btnValues.ControlTag = "a8aca3c1-02b1-4ae5-8af5-b092424b3fb1"
        Me.btnValues.ImageTransparentColor = System.Drawing.Color.Transparent
        Me.btnValues.Style = AddinExpress.MSO.ADXMsoButtonStyle.adxMsoButtonAutomatic
        Me.btnValues.Tag = "65"
        Me.btnValues.UpdateCounter = 5
        '
        'btnFormats
        '
        Me.btnFormats.Caption = "Formats"
        Me.btnFormats.ControlTag = "9e4560c6-4ff8-4e53-8bb0-817face9768f"
        Me.btnFormats.ImageTransparentColor = System.Drawing.Color.Transparent
        Me.btnFormats.Style = AddinExpress.MSO.ADXMsoButtonStyle.adxMsoButtonAutomatic
        Me.btnFormats.Tag = "66"
        Me.btnFormats.UpdateCounter = 5
        '
        'btnComments_pp
        '
        Me.btnComments_pp.Caption = "Comments"
        Me.btnComments_pp.ControlTag = "45869ace-6f9d-4b91-83e1-f50dc77fff16"
        Me.btnComments_pp.ImageTransparentColor = System.Drawing.Color.Transparent
        Me.btnComments_pp.Style = AddinExpress.MSO.ADXMsoButtonStyle.adxMsoButtonAutomatic
        Me.btnComments_pp.Tag = "67"
        Me.btnComments_pp.UpdateCounter = 5
        '
        'btnColumnWidths
        '
        Me.btnColumnWidths.Caption = "Column Widths"
        Me.btnColumnWidths.ControlTag = "f80a1fa9-dd0b-4cf5-aefb-747842ab171a"
        Me.btnColumnWidths.ImageTransparentColor = System.Drawing.Color.Transparent
        Me.btnColumnWidths.Style = AddinExpress.MSO.ADXMsoButtonStyle.adxMsoButtonAutomatic
        Me.btnColumnWidths.Tag = "68"
        Me.btnColumnWidths.UpdateCounter = 5
        '
        'btnDataValidation
        '
        Me.btnDataValidation.Caption = "Data Validation"
        Me.btnDataValidation.ControlTag = "eaf44d52-f3c0-412b-946d-843275a48ee7"
        Me.btnDataValidation.ImageTransparentColor = System.Drawing.Color.Transparent
        Me.btnDataValidation.Style = AddinExpress.MSO.ADXMsoButtonStyle.adxMsoButtonAutomatic
        Me.btnDataValidation.Tag = "69"
        Me.btnDataValidation.UpdateCounter = 5
        '
        'btnPasteNone
        '
        Me.btnPasteNone.Caption = "Paste None"
        Me.btnPasteNone.ControlTag = "05963d19-0ca1-42cd-bb82-dcd0079806ab"
        Me.btnPasteNone.Image = 30
        Me.btnPasteNone.ImageTransparentColor = System.Drawing.Color.Cyan
        Me.btnPasteNone.State = AddinExpress.MSO.ADXMsoButtonState.adxMsoButtonDown
        Me.btnPasteNone.Style = AddinExpress.MSO.ADXMsoButtonStyle.adxMsoButtonIcon
        Me.btnPasteNone.Tag = "71"
        Me.btnPasteNone.UpdateCounter = 8
        '
        'btnPasteAdd
        '
        Me.btnPasteAdd.Caption = "Paste Add"
        Me.btnPasteAdd.ControlTag = "3ed94be6-7410-495c-a39c-4ecff2149489"
        Me.btnPasteAdd.Image = 8
        Me.btnPasteAdd.ImageTransparentColor = System.Drawing.Color.Cyan
        Me.btnPasteAdd.Style = AddinExpress.MSO.ADXMsoButtonStyle.adxMsoButtonIcon
        Me.btnPasteAdd.Tag = "72"
        Me.btnPasteAdd.UpdateCounter = 5
        '
        'btnPasteSubtract
        '
        Me.btnPasteSubtract.Caption = "Paste Subtract"
        Me.btnPasteSubtract.ControlTag = "891fcd06-9695-47cc-b13d-55d41462da01"
        Me.btnPasteSubtract.Image = 13
        Me.btnPasteSubtract.ImageTransparentColor = System.Drawing.Color.Cyan
        Me.btnPasteSubtract.Style = AddinExpress.MSO.ADXMsoButtonStyle.adxMsoButtonIcon
        Me.btnPasteSubtract.Tag = "73"
        Me.btnPasteSubtract.UpdateCounter = 6
        '
        'btnPasteMultiply
        '
        Me.btnPasteMultiply.Caption = "Paste Multiply"
        Me.btnPasteMultiply.ControlTag = "2fb848e6-a4aa-4de1-bd3b-c2a2e720722a"
        Me.btnPasteMultiply.Image = 10
        Me.btnPasteMultiply.ImageTransparentColor = System.Drawing.Color.Cyan
        Me.btnPasteMultiply.Style = AddinExpress.MSO.ADXMsoButtonStyle.adxMsoButtonIcon
        Me.btnPasteMultiply.Tag = "74"
        Me.btnPasteMultiply.UpdateCounter = 5
        '
        'btnPasteDivide
        '
        Me.btnPasteDivide.Caption = "Paste Divide"
        Me.btnPasteDivide.ControlTag = "990b6bfc-5ca4-4950-9220-4fb9b3b4aa51"
        Me.btnPasteDivide.Image = 9
        Me.btnPasteDivide.ImageTransparentColor = System.Drawing.Color.Cyan
        Me.btnPasteDivide.Style = AddinExpress.MSO.ADXMsoButtonStyle.adxMsoButtonIcon
        Me.btnPasteDivide.Tag = "75"
        Me.btnPasteDivide.UpdateCounter = 5
        '
        'btnSkipBlanks
        '
        Me.btnSkipBlanks.Caption = "Skip Blanks"
        Me.btnSkipBlanks.ControlTag = "ab5ed4c0-e7a6-4408-8752-40309c986a82"
        Me.btnSkipBlanks.Image = 12
        Me.btnSkipBlanks.ImageTransparentColor = System.Drawing.Color.Cyan
        Me.btnSkipBlanks.Style = AddinExpress.MSO.ADXMsoButtonStyle.adxMsoButtonIcon
        Me.btnSkipBlanks.Tag = "76"
        Me.btnSkipBlanks.UpdateCounter = 6
        '
        'btnTranspose
        '
        Me.btnTranspose.Caption = "Transpose"
        Me.btnTranspose.ControlTag = "209306a8-485e-4e62-ac5f-1470b044f671"
        Me.btnTranspose.Image = 14
        Me.btnTranspose.ImageTransparentColor = System.Drawing.Color.Cyan
        Me.btnTranspose.Style = AddinExpress.MSO.ADXMsoButtonStyle.adxMsoButtonIcon
        Me.btnTranspose.Tag = "77"
        Me.btnTranspose.UpdateCounter = 6
        '
        'AdxRibbonTab
        '
        Me.AdxRibbonTab.Caption = "Add-in Express Toys for Excel (VB.NET)"
        Me.AdxRibbonTab.Controls.Add(Me.RibbonGroup)
        Me.AdxRibbonTab.Id = "adxRibbonTab_6fc5921f86b4434e921fa911c6a34ba2"
        Me.AdxRibbonTab.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook
        '
        'RibbonGroup
        '
        Me.RibbonGroup.Caption = "Add-in Express Toys"
        Me.RibbonGroup.Controls.Add(Me.RibbonButtonAbout)
        Me.RibbonGroup.Controls.Add(Me.RibbonSeparator1)
        Me.RibbonGroup.Controls.Add(Me.RibbonButtonGroup1)
        Me.RibbonGroup.Controls.Add(Me.RibbonButtonGroup2)
        Me.RibbonGroup.Id = "adxRibbonGroup_499f6d5b1f4a4a05a98defaa6b91f4ec"
        Me.RibbonGroup.ImageTransparentColor = System.Drawing.Color.Transparent
        Me.RibbonGroup.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook
        '
        'RibbonButtonAbout
        '
        Me.RibbonButtonAbout.Caption = "About"
        Me.RibbonButtonAbout.Id = "adxRibbonButton_411ddf45fdbc40ec8364553f47e5c7ee"
        Me.RibbonButtonAbout.Image = 0
        Me.RibbonButtonAbout.ImageList = Me.ImageList32
        Me.RibbonButtonAbout.ImageTransparentColor = System.Drawing.Color.White
        Me.RibbonButtonAbout.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook
        Me.RibbonButtonAbout.Size = AddinExpress.MSO.ADXRibbonXControlSize.Large
        '
        'ImageList32
        '
        Me.ImageList32.ImageStream = CType(resources.GetObject("ImageList32.ImageStream"), System.Windows.Forms.ImageListStreamer)
        Me.ImageList32.TransparentColor = System.Drawing.Color.Transparent
        Me.ImageList32.Images.SetKeyName(0, "button32.bmp")
        '
        'RibbonSeparator1
        '
        Me.RibbonSeparator1.Id = "adxRibbonSeparator_e82b6c6a077843e8a403716435d9af28"
        Me.RibbonSeparator1.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook
        '
        'RibbonButtonGroup1
        '
        Me.RibbonButtonGroup1.Controls.Add(Me.RibbonButtonWrapText)
        Me.RibbonButtonGroup1.Controls.Add(Me.RibbonButtonShrinkToFit)
        Me.RibbonButtonGroup1.Controls.Add(Me.RibbonGalleryUnderline)
        Me.RibbonButtonGroup1.Controls.Add(Me.RibbonSeparator2)
        Me.RibbonButtonGroup1.Controls.Add(Me.RibbonButtonAlignTop)
        Me.RibbonButtonGroup1.Controls.Add(Me.RibbonButtonAlignCenter)
        Me.RibbonButtonGroup1.Controls.Add(Me.RibbonButtonAlignBottom)
        Me.RibbonButtonGroup1.Controls.Add(Me.RibbonSeparator3)
        Me.RibbonButtonGroup1.Controls.Add(Me.RibbonButtonMergeCellsTopDown)
        Me.RibbonButtonGroup1.Controls.Add(Me.RibbonButtonMergeTop)
        Me.RibbonButtonGroup1.Controls.Add(Me.RibbonButtonMergeCenter)
        Me.RibbonButtonGroup1.Controls.Add(Me.RibbonButtonMergeBottom)
        Me.RibbonButtonGroup1.Id = "adxRibbonButtonGroup_9d6ede34cef340459747d42c968b1b9d"
        Me.RibbonButtonGroup1.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook
        '
        'RibbonButtonWrapText
        '
        Me.RibbonButtonWrapText.Caption = "Wrap Text"
        Me.RibbonButtonWrapText.Id = "adxRibbonButton_2e5f7b2c46174a46bd99c6a0c9ccf7b5"
        Me.RibbonButtonWrapText.Image = 3
        Me.RibbonButtonWrapText.ImageTransparentColor = System.Drawing.Color.Cyan
        Me.RibbonButtonWrapText.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook
        Me.RibbonButtonWrapText.ShowCaption = False
        '
        'RibbonButtonShrinkToFit
        '
        Me.RibbonButtonShrinkToFit.Caption = "Shrink To Fit"
        Me.RibbonButtonShrinkToFit.Id = "adxRibbonButton_9910d1eba5bb4e3c935452a9b50f20c2"
        Me.RibbonButtonShrinkToFit.Image = 28
        Me.RibbonButtonShrinkToFit.ImageTransparentColor = System.Drawing.Color.Cyan
        Me.RibbonButtonShrinkToFit.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook
        Me.RibbonButtonShrinkToFit.ShowCaption = False
        '
        'RibbonGalleryUnderline
        '
        Me.RibbonGalleryUnderline.Caption = "Underline"
        Me.RibbonGalleryUnderline.Controls.Add(Me.RibbonButtonNone)
        Me.RibbonGalleryUnderline.Controls.Add(Me.RibbonButtonSingle)
        Me.RibbonGalleryUnderline.Controls.Add(Me.RibbonButtonDouble)
        Me.RibbonGalleryUnderline.Controls.Add(Me.RibbonButtonSingleAccounting)
        Me.RibbonGalleryUnderline.Controls.Add(Me.RibbonButtonDoubleAccounting)
        Me.RibbonGalleryUnderline.Id = "adxRibbonGallery_e93f25712a94486ba2ad2ab67767ec18"
        Me.RibbonGalleryUnderline.ImageTransparentColor = System.Drawing.Color.Transparent
        Me.RibbonGalleryUnderline.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook
        '
        'RibbonButtonNone
        '
        Me.RibbonButtonNone.Caption = "None"
        Me.RibbonButtonNone.Id = "adxRibbonButton_82eddd0344ac48dca9d3148208e7b7aa"
        Me.RibbonButtonNone.Image = 22
        Me.RibbonButtonNone.ImageTransparentColor = System.Drawing.Color.Cyan
        Me.RibbonButtonNone.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook
        '
        'RibbonButtonSingle
        '
        Me.RibbonButtonSingle.Caption = "Single"
        Me.RibbonButtonSingle.Id = "adxRibbonButton_88686c84262248ddbd8ea9dda5de4b3f"
        Me.RibbonButtonSingle.Image = 23
        Me.RibbonButtonSingle.ImageTransparentColor = System.Drawing.Color.Cyan
        Me.RibbonButtonSingle.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook
        '
        'RibbonButtonDouble
        '
        Me.RibbonButtonDouble.Caption = "Double"
        Me.RibbonButtonDouble.Id = "adxRibbonButton_ed3179d46ecc4007a8b743bfc8775990"
        Me.RibbonButtonDouble.Image = 20
        Me.RibbonButtonDouble.ImageTransparentColor = System.Drawing.Color.Cyan
        Me.RibbonButtonDouble.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook
        '
        'RibbonButtonSingleAccounting
        '
        Me.RibbonButtonSingleAccounting.Caption = "Single Accounting"
        Me.RibbonButtonSingleAccounting.Id = "adxRibbonButton_3b4567cf30f448979ad4e2278cc40db1"
        Me.RibbonButtonSingleAccounting.Image = 24
        Me.RibbonButtonSingleAccounting.ImageTransparentColor = System.Drawing.Color.Cyan
        Me.RibbonButtonSingleAccounting.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook
        '
        'RibbonButtonDoubleAccounting
        '
        Me.RibbonButtonDoubleAccounting.Caption = "Double Accounting"
        Me.RibbonButtonDoubleAccounting.Id = "adxRibbonButton_585cad643cfb4b2bbb0c245f73c11f30"
        Me.RibbonButtonDoubleAccounting.Image = 21
        Me.RibbonButtonDoubleAccounting.ImageTransparentColor = System.Drawing.Color.Cyan
        Me.RibbonButtonDoubleAccounting.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook
        '
        'RibbonSeparator2
        '
        Me.RibbonSeparator2.Id = "adxRibbonSeparator_8952b6b4e49a4fce9e37a4da946bb252"
        Me.RibbonSeparator2.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook
        '
        'RibbonButtonAlignTop
        '
        Me.RibbonButtonAlignTop.Caption = "Align Top"
        Me.RibbonButtonAlignTop.Id = "adxRibbonButton_a05511b93c484d7999d469082e458ac6"
        Me.RibbonButtonAlignTop.Image = 31
        Me.RibbonButtonAlignTop.ImageTransparentColor = System.Drawing.Color.Cyan
        Me.RibbonButtonAlignTop.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook
        Me.RibbonButtonAlignTop.ShowCaption = False
        '
        'RibbonButtonAlignCenter
        '
        Me.RibbonButtonAlignCenter.Caption = "Align Center"
        Me.RibbonButtonAlignCenter.Id = "adxRibbonButton_3c9d566723544345aba214b782e2951c"
        Me.RibbonButtonAlignCenter.Image = 2
        Me.RibbonButtonAlignCenter.ImageTransparentColor = System.Drawing.Color.Cyan
        Me.RibbonButtonAlignCenter.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook
        Me.RibbonButtonAlignCenter.ShowCaption = False
        '
        'RibbonButtonAlignBottom
        '
        Me.RibbonButtonAlignBottom.Caption = "Align Bottom"
        Me.RibbonButtonAlignBottom.Id = "adxRibbonButton_935bd2ea8b7c4209a8e93608eae474f4"
        Me.RibbonButtonAlignBottom.Image = 1
        Me.RibbonButtonAlignBottom.ImageTransparentColor = System.Drawing.Color.Cyan
        Me.RibbonButtonAlignBottom.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook
        Me.RibbonButtonAlignBottom.ShowCaption = False
        '
        'RibbonSeparator3
        '
        Me.RibbonSeparator3.Id = "adxRibbonSeparator_f53f1fe0321344ee91b5013220568784"
        Me.RibbonSeparator3.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook
        '
        'RibbonButtonMergeCellsTopDown
        '
        Me.RibbonButtonMergeCellsTopDown.Caption = "Merge Cells Top-down"
        Me.RibbonButtonMergeCellsTopDown.Id = "adxRibbonButton_ddf63845c83647d69e193348dd396143"
        Me.RibbonButtonMergeCellsTopDown.Image = 4
        Me.RibbonButtonMergeCellsTopDown.ImageTransparentColor = System.Drawing.Color.Cyan
        Me.RibbonButtonMergeCellsTopDown.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook
        Me.RibbonButtonMergeCellsTopDown.ShowCaption = False
        '
        'RibbonButtonMergeTop
        '
        Me.RibbonButtonMergeTop.Caption = "Merge and Top"
        Me.RibbonButtonMergeTop.Id = "adxRibbonButton_255841b12e3c4579ad7ae45caaec08d5"
        Me.RibbonButtonMergeTop.Image = 7
        Me.RibbonButtonMergeTop.ImageTransparentColor = System.Drawing.Color.Cyan
        Me.RibbonButtonMergeTop.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook
        Me.RibbonButtonMergeTop.ShowCaption = False
        '
        'RibbonButtonMergeCenter
        '
        Me.RibbonButtonMergeCenter.Caption = "Merge and Center"
        Me.RibbonButtonMergeCenter.Id = "adxRibbonButton_8fcf89c12d11465cb98f9413984e66a2"
        Me.RibbonButtonMergeCenter.Image = 6
        Me.RibbonButtonMergeCenter.ImageTransparentColor = System.Drawing.Color.Cyan
        Me.RibbonButtonMergeCenter.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook
        Me.RibbonButtonMergeCenter.ShowCaption = False
        '
        'RibbonButtonMergeBottom
        '
        Me.RibbonButtonMergeBottom.Caption = "Merge and Bottom"
        Me.RibbonButtonMergeBottom.Id = "adxRibbonButton_f5d911efb0f94809ba2b8801cf6e23f6"
        Me.RibbonButtonMergeBottom.Image = 5
        Me.RibbonButtonMergeBottom.ImageTransparentColor = System.Drawing.Color.Cyan
        Me.RibbonButtonMergeBottom.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook
        Me.RibbonButtonMergeBottom.ShowCaption = False
        '
        'RibbonButtonGroup2
        '
        Me.RibbonButtonGroup2.Controls.Add(Me.RibbonGalleryShowHide)
        Me.RibbonButtonGroup2.Controls.Add(Me.RibbonSeparator4)
        Me.RibbonButtonGroup2.Controls.Add(Me.RibbonMenuPasteSpecial)
        Me.RibbonButtonGroup2.Controls.Add(Me.RibbonButtonPasteNone)
        Me.RibbonButtonGroup2.Controls.Add(Me.RibbonButtonPasteAdd)
        Me.RibbonButtonGroup2.Controls.Add(Me.RibbonButtonPasteSubtract)
        Me.RibbonButtonGroup2.Controls.Add(Me.RibbonButtonPasteMultiply)
        Me.RibbonButtonGroup2.Controls.Add(Me.RibbonButtonPasteDivide)
        Me.RibbonButtonGroup2.Controls.Add(Me.RibbonButtonSkipBlanks)
        Me.RibbonButtonGroup2.Controls.Add(Me.RibbonButtonTranspose)
        Me.RibbonButtonGroup2.Id = "adxRibbonButtonGroup_ab48ae38959a49518c73eaeb093b7d04"
        Me.RibbonButtonGroup2.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook
        '
        'RibbonGalleryShowHide
        '
        Me.RibbonGalleryShowHide.Caption = "Show/Hide"
        Me.RibbonGalleryShowHide.Controls.Add(Me.RibbonButtonShowHideComments)
        Me.RibbonGalleryShowHide.Controls.Add(Me.RibbonButtonShowHideZeroValues)
        Me.RibbonGalleryShowHide.Controls.Add(Me.RibbonButtonShowHideFormulas)
        Me.RibbonGalleryShowHide.Controls.Add(Me.RibbonButtonShowHideGridlines)
        Me.RibbonGalleryShowHide.Controls.Add(Me.RibbonButtonShowHidePageBreaks)
        Me.RibbonGalleryShowHide.Id = "adxRibbonGallery_9cdd914a1d5048d28ec2f1125ccd5330"
        Me.RibbonGalleryShowHide.ImageTransparentColor = System.Drawing.Color.Transparent
        Me.RibbonGalleryShowHide.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook
        '
        'RibbonButtonShowHideComments
        '
        Me.RibbonButtonShowHideComments.Caption = "Comments"
        Me.RibbonButtonShowHideComments.Id = "adxRibbonButton_77f80f880b314029bef300ee30f3f484"
        Me.RibbonButtonShowHideComments.Image = 15
        Me.RibbonButtonShowHideComments.ImageTransparentColor = System.Drawing.Color.Cyan
        Me.RibbonButtonShowHideComments.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook
        '
        'RibbonButtonShowHideZeroValues
        '
        Me.RibbonButtonShowHideZeroValues.Caption = "Zero Values"
        Me.RibbonButtonShowHideZeroValues.Id = "adxRibbonButton_052c81af7e8744afa31be0db0faa9c3a"
        Me.RibbonButtonShowHideZeroValues.Image = 19
        Me.RibbonButtonShowHideZeroValues.ImageTransparentColor = System.Drawing.Color.Cyan
        Me.RibbonButtonShowHideZeroValues.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook
        '
        'RibbonButtonShowHideFormulas
        '
        Me.RibbonButtonShowHideFormulas.Caption = "Formulas"
        Me.RibbonButtonShowHideFormulas.Id = "adxRibbonButton_81e72881a9f246d2a26af55b2658b360"
        Me.RibbonButtonShowHideFormulas.Image = 16
        Me.RibbonButtonShowHideFormulas.ImageTransparentColor = System.Drawing.Color.Cyan
        Me.RibbonButtonShowHideFormulas.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook
        '
        'RibbonButtonShowHideGridlines
        '
        Me.RibbonButtonShowHideGridlines.Caption = "Gridlines"
        Me.RibbonButtonShowHideGridlines.Id = "adxRibbonButton_bd24636365874b39abfa85aadff2f836"
        Me.RibbonButtonShowHideGridlines.Image = 17
        Me.RibbonButtonShowHideGridlines.ImageTransparentColor = System.Drawing.Color.Cyan
        Me.RibbonButtonShowHideGridlines.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook
        '
        'RibbonButtonShowHidePageBreaks
        '
        Me.RibbonButtonShowHidePageBreaks.Caption = "Page Breaks"
        Me.RibbonButtonShowHidePageBreaks.Id = "adxRibbonButton_fd0d1906caf64c319988b513ec5fa34c"
        Me.RibbonButtonShowHidePageBreaks.Image = 18
        Me.RibbonButtonShowHidePageBreaks.ImageTransparentColor = System.Drawing.Color.Cyan
        Me.RibbonButtonShowHidePageBreaks.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook
        '
        'RibbonSeparator4
        '
        Me.RibbonSeparator4.Id = "adxRibbonSeparator_d306b97778b043009d46054a274e4fef"
        Me.RibbonSeparator4.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook
        '
        'RibbonMenuPasteSpecial
        '
        Me.RibbonMenuPasteSpecial.Caption = "Paste Special"
        Me.RibbonMenuPasteSpecial.Controls.Add(Me.RibbonButtonAll)
        Me.RibbonMenuPasteSpecial.Controls.Add(Me.RibbonButtonAllExceptBorders)
        Me.RibbonMenuPasteSpecial.Controls.Add(Me.RibbonButtonPasteLinks)
        Me.RibbonMenuPasteSpecial.Controls.Add(Me.RibbonMenuSeparator1)
        Me.RibbonMenuPasteSpecial.Controls.Add(Me.RibbonButtonFormulas)
        Me.RibbonMenuPasteSpecial.Controls.Add(Me.RibbonButtonValues)
        Me.RibbonMenuPasteSpecial.Controls.Add(Me.RibbonButtonFormats)
        Me.RibbonMenuPasteSpecial.Controls.Add(Me.RibbonButtonComments)
        Me.RibbonMenuPasteSpecial.Controls.Add(Me.RibbonButtonColumnWidths)
        Me.RibbonMenuPasteSpecial.Controls.Add(Me.RibbonButtonDataValidation)
        Me.RibbonMenuPasteSpecial.Id = "adxRibbonMenu_f60d2c5703ef42a99cace4eba560669b"
        Me.RibbonMenuPasteSpecial.ImageTransparentColor = System.Drawing.Color.Transparent
        Me.RibbonMenuPasteSpecial.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook
        '
        'RibbonButtonAll
        '
        Me.RibbonButtonAll.Caption = "All"
        Me.RibbonButtonAll.Id = "adxRibbonButton_f0d90c0f9c704420b054075c7e8748e9"
        Me.RibbonButtonAll.ImageTransparentColor = System.Drawing.Color.Transparent
        Me.RibbonButtonAll.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook
        '
        'RibbonButtonAllExceptBorders
        '
        Me.RibbonButtonAllExceptBorders.Caption = "All Except Borders"
        Me.RibbonButtonAllExceptBorders.Id = "adxRibbonButton_302d11ea4cff46e79f89ea3303abd2ce"
        Me.RibbonButtonAllExceptBorders.ImageTransparentColor = System.Drawing.Color.Transparent
        Me.RibbonButtonAllExceptBorders.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook
        '
        'RibbonButtonPasteLinks
        '
        Me.RibbonButtonPasteLinks.Caption = "Paste Links"
        Me.RibbonButtonPasteLinks.Id = "adxRibbonButton_2c3565a8f334465db851309a23c7705b"
        Me.RibbonButtonPasteLinks.ImageTransparentColor = System.Drawing.Color.Transparent
        Me.RibbonButtonPasteLinks.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook
        '
        'RibbonMenuSeparator1
        '
        Me.RibbonMenuSeparator1.Id = "adxRibbonMenuSeparator_771889e40114477387e34b34d8d9b0bf"
        Me.RibbonMenuSeparator1.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook
        '
        'RibbonButtonFormulas
        '
        Me.RibbonButtonFormulas.Caption = "Formulas"
        Me.RibbonButtonFormulas.Id = "adxRibbonButton_78b9c239a0094fccae0aac4665b10fb9"
        Me.RibbonButtonFormulas.ImageTransparentColor = System.Drawing.Color.Transparent
        Me.RibbonButtonFormulas.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook
        '
        'RibbonButtonValues
        '
        Me.RibbonButtonValues.Caption = "Values"
        Me.RibbonButtonValues.Id = "adxRibbonButton_15e63f8c9f8c476abc6766fa7776c0f5"
        Me.RibbonButtonValues.ImageTransparentColor = System.Drawing.Color.Transparent
        Me.RibbonButtonValues.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook
        '
        'RibbonButtonFormats
        '
        Me.RibbonButtonFormats.Caption = "Formats"
        Me.RibbonButtonFormats.Id = "adxRibbonButton_799eff55a02a487d991d42dc75595519"
        Me.RibbonButtonFormats.ImageTransparentColor = System.Drawing.Color.Transparent
        Me.RibbonButtonFormats.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook
        '
        'RibbonButtonComments
        '
        Me.RibbonButtonComments.Caption = "Comments"
        Me.RibbonButtonComments.Id = "adxRibbonButton_3c1bd7edd8194933bfe689df3816e982"
        Me.RibbonButtonComments.ImageTransparentColor = System.Drawing.Color.Transparent
        Me.RibbonButtonComments.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook
        '
        'RibbonButtonColumnWidths
        '
        Me.RibbonButtonColumnWidths.Caption = "Column Widths"
        Me.RibbonButtonColumnWidths.Id = "adxRibbonButton_ddbe8d266456460d8fde6cfb38b2d4c0"
        Me.RibbonButtonColumnWidths.ImageTransparentColor = System.Drawing.Color.Transparent
        Me.RibbonButtonColumnWidths.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook
        '
        'RibbonButtonDataValidation
        '
        Me.RibbonButtonDataValidation.Caption = "Data Validation"
        Me.RibbonButtonDataValidation.Id = "adxRibbonButton_c804172dc5014a59907376c06a95fd47"
        Me.RibbonButtonDataValidation.ImageTransparentColor = System.Drawing.Color.Transparent
        Me.RibbonButtonDataValidation.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook
        '
        'RibbonButtonPasteNone
        '
        Me.RibbonButtonPasteNone.Caption = "Paste None"
        Me.RibbonButtonPasteNone.Id = "adxRibbonButton_b1b44cd1e62c40d68f14cdb45ae81119"
        Me.RibbonButtonPasteNone.Image = 30
        Me.RibbonButtonPasteNone.ImageTransparentColor = System.Drawing.Color.Cyan
        Me.RibbonButtonPasteNone.Pressed = True
        Me.RibbonButtonPasteNone.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook
        Me.RibbonButtonPasteNone.ShowCaption = False
        Me.RibbonButtonPasteNone.Tag = 71
        Me.RibbonButtonPasteNone.ToggleButton = True
        '
        'RibbonButtonPasteAdd
        '
        Me.RibbonButtonPasteAdd.Caption = "Paste Add"
        Me.RibbonButtonPasteAdd.Id = "adxRibbonButton_4d3fe17d80f64f238d47fdf9c1de12f4"
        Me.RibbonButtonPasteAdd.Image = 8
        Me.RibbonButtonPasteAdd.ImageTransparentColor = System.Drawing.Color.Cyan
        Me.RibbonButtonPasteAdd.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook
        Me.RibbonButtonPasteAdd.ShowCaption = False
        Me.RibbonButtonPasteAdd.Tag = 72
        Me.RibbonButtonPasteAdd.ToggleButton = True
        '
        'RibbonButtonPasteSubtract
        '
        Me.RibbonButtonPasteSubtract.Caption = "Paste Subtract"
        Me.RibbonButtonPasteSubtract.Id = "adxRibbonButton_611a9b27ba2145cfa487c0ebb1c38990"
        Me.RibbonButtonPasteSubtract.Image = 13
        Me.RibbonButtonPasteSubtract.ImageTransparentColor = System.Drawing.Color.Cyan
        Me.RibbonButtonPasteSubtract.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook
        Me.RibbonButtonPasteSubtract.ShowCaption = False
        Me.RibbonButtonPasteSubtract.Tag = 73
        Me.RibbonButtonPasteSubtract.ToggleButton = True
        '
        'RibbonButtonPasteMultiply
        '
        Me.RibbonButtonPasteMultiply.Caption = "Paste Multiply"
        Me.RibbonButtonPasteMultiply.Id = "adxRibbonButton_e6b33dd4c113407187289f351147c824"
        Me.RibbonButtonPasteMultiply.Image = 10
        Me.RibbonButtonPasteMultiply.ImageTransparentColor = System.Drawing.Color.Cyan
        Me.RibbonButtonPasteMultiply.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook
        Me.RibbonButtonPasteMultiply.ShowCaption = False
        Me.RibbonButtonPasteMultiply.Tag = 74
        Me.RibbonButtonPasteMultiply.ToggleButton = True
        '
        'RibbonButtonPasteDivide
        '
        Me.RibbonButtonPasteDivide.Caption = "Paste Divide"
        Me.RibbonButtonPasteDivide.Id = "adxRibbonButton_32c75946046e48dc97d1427f4011c75b"
        Me.RibbonButtonPasteDivide.Image = 9
        Me.RibbonButtonPasteDivide.ImageTransparentColor = System.Drawing.Color.Cyan
        Me.RibbonButtonPasteDivide.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook
        Me.RibbonButtonPasteDivide.ShowCaption = False
        Me.RibbonButtonPasteDivide.Tag = 75
        Me.RibbonButtonPasteDivide.ToggleButton = True
        '
        'RibbonButtonSkipBlanks
        '
        Me.RibbonButtonSkipBlanks.Caption = "Skip Blanks"
        Me.RibbonButtonSkipBlanks.Id = "adxRibbonButton_353df2dd971d49ffb9548ce0ca4da178"
        Me.RibbonButtonSkipBlanks.Image = 12
        Me.RibbonButtonSkipBlanks.ImageTransparentColor = System.Drawing.Color.Cyan
        Me.RibbonButtonSkipBlanks.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook
        Me.RibbonButtonSkipBlanks.ShowCaption = False
        Me.RibbonButtonSkipBlanks.Tag = 76
        Me.RibbonButtonSkipBlanks.ToggleButton = True
        '
        'RibbonButtonTranspose
        '
        Me.RibbonButtonTranspose.Caption = "Transpose"
        Me.RibbonButtonTranspose.Id = "adxRibbonButton_c4937b71bf0c40298cab2fbe837beb34"
        Me.RibbonButtonTranspose.Image = 14
        Me.RibbonButtonTranspose.ImageTransparentColor = System.Drawing.Color.Cyan
        Me.RibbonButtonTranspose.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook
        Me.RibbonButtonTranspose.ShowCaption = False
        Me.RibbonButtonTranspose.Tag = 77
        Me.RibbonButtonTranspose.ToggleButton = True
        '
        'AddinModule
        '
        Me.AddinName = "Add-in Express Toys for Excel (VB.NET)"
        Me.Description = "Add-in Express Toys for Excel (VB.NET)"
        Me.Images = Me.imageList16
        Me.SupportedApps = AddinExpress.MSO.ADXOfficeHostApp.ohaExcel

    End Sub

#End Region

#Region " ADX automatic code "

    'Required by Add-in Express - do not modify
    'the methods within this region

    Public Overrides Function GetContainer() As System.ComponentModel.IContainer
        GetContainer = components
    End Function

    <ComRegisterFunctionAttribute()> _
    Public Shared Sub AddinRegister(ByVal t As Type)
        AddinExpress.MSO.ADXAddinModule.ADXRegister(t)
    End Sub

    <ComUnregisterFunctionAttribute()> _
    Public Shared Sub AddinUnregister(ByVal t As Type)
        AddinExpress.MSO.ADXAddinModule.ADXUnregister(t)
    End Sub

    Public Overrides Sub UninstallControls()
        MyBase.UninstallControls()
    End Sub

#End Region

    'Add-in Module Implementation

    Public Sub New()
        MyBase.New()

        Application.EnableVisualStyles()
        'This call is required by the Component Designer
        InitializeComponent()

        'Please add any initialization code to the AddinInitialize event handler
    End Sub

    Public Shared Shadows ReadOnly Property CurrentInstance() As AddinModule
        Get
            Return CType(AddinExpress.MSO.ADXAddinModule.CurrentInstance, AddinModule)
        End Get
    End Property

    Public ReadOnly Property ExcelApp() As Excel._Application
        Get
            Return CType(HostApplication, Excel._Application)
        End Get
    End Property

    Private Sub AddinModule_AddinInitialize(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.AddinInitialize
        If StartMode = AddinExpress.MSO.ADXStartMode.smFirstStart Then
            adxCommandBar1.Position = AddinExpress.MSO.ADXMsoBarPosition.adxMsoBarFloating
            DoAbout()
        End If
    End Sub

    Private Sub AddinModule_OnError(ByVal e As AddinExpress.MSO.ADXErrorEventArgs) Handles MyBase.OnError
        e.Handled = True
        MessageBox.Show(e.ADXError.Message, e.ADXError.Source, MessageBoxButtons.OK, MessageBoxIcon.Error)
    End Sub

#Region "CommandBar and Ribbon buttons"

    ' about
    Private Sub btnAboutADXToys2_Click(ByVal sender As Object) Handles btnAboutADXToys2.Click
        DoAbout()
    End Sub

    Private Sub RibbonButtonAbout_OnClick(sender As System.Object, control As AddinExpress.MSO.IRibbonControl, pressed As System.Boolean) Handles RibbonButtonAbout.OnClick
        btnAboutADXToys2_Click(Nothing)
    End Sub

    ' formatting
    Private Sub btnWrapText_Click(ByVal sender As Object) Handles btnWrapText.Click
        DoCellFormat(XldCellFormat.cfWrapText)
    End Sub

    Private Sub RibbonButtonWrapText_OnClick(sender As System.Object, control As AddinExpress.MSO.IRibbonControl, pressed As System.Boolean) Handles RibbonButtonWrapText.OnClick
        btnWrapText_Click(Nothing)
    End Sub

    Private Sub btnShrinkToFit_Click(ByVal sender As Object) Handles btnShrinkToFit.Click
        DoCellFormat(XldCellFormat.cfShrinkToFit)
    End Sub

    Private Sub RibbonButtonShrinkToFit_OnClick(sender As System.Object, control As AddinExpress.MSO.IRibbonControl, pressed As System.Boolean) Handles RibbonButtonShrinkToFit.OnClick
        btnShrinkToFit_Click(Nothing)
    End Sub

    Private Sub btnNone_Click(ByVal sender As Object) Handles btnNone.Click
        DoCellFormat(XldCellFormat.cfUnderlineNone)
    End Sub

    Private Sub RibbonButtonNone_OnClick(sender As System.Object, control As AddinExpress.MSO.IRibbonControl, pressed As System.Boolean) Handles RibbonButtonNone.OnClick
        btnNone_Click(Nothing)
    End Sub

    Private Sub btnSingle_Click(ByVal sender As Object) Handles btnSingle.Click
        DoCellFormat(XldCellFormat.cfUnderlineSingle)
    End Sub

    Private Sub RibbonButtonSingle_OnClick(sender As System.Object, control As AddinExpress.MSO.IRibbonControl, pressed As System.Boolean) Handles RibbonButtonSingle.OnClick
        btnSingle_Click(Nothing)
    End Sub

    Private Sub btnDouble_Click(ByVal sender As Object) Handles btnDouble.Click
        DoCellFormat(XldCellFormat.cfUnderlineDouble)
    End Sub

    Private Sub RibbonButtonDouble_OnClick(sender As System.Object, control As AddinExpress.MSO.IRibbonControl, pressed As System.Boolean) Handles RibbonButtonDouble.OnClick
        btnDouble_Click(Nothing)
    End Sub

    Private Sub btnSingleAccounting_Click(ByVal sender As Object) Handles btnSingleAccounting.Click
        DoCellFormat(XldCellFormat.cfUnderlineSingleAccounting)
    End Sub

    Private Sub RibbonButtonSingleAccounting_OnClick(sender As System.Object, control As AddinExpress.MSO.IRibbonControl, pressed As System.Boolean) Handles RibbonButtonSingleAccounting.OnClick
        btnSingleAccounting_Click(Nothing)
    End Sub

    Private Sub btnDoubleAccounting_Click(ByVal sender As Object) Handles btnDoubleAccounting.Click
        DoCellFormat(XldCellFormat.cfUnderlineDoubleAccounting)
    End Sub

    Private Sub RibbonButtonDoubleAccounting_OnClick(sender As System.Object, control As AddinExpress.MSO.IRibbonControl, pressed As System.Boolean) Handles RibbonButtonDoubleAccounting.OnClick
        btnDoubleAccounting_Click(Nothing)
    End Sub

    ' align
    Private Sub btnAlignTop_Click(ByVal sender As Object) Handles btnAlignTop.Click
        DoVAlign(XldVAlignment.vaTop)
    End Sub

    Private Sub RibbonButtonAlignTop_OnClick(sender As System.Object, control As AddinExpress.MSO.IRibbonControl, pressed As System.Boolean) Handles RibbonButtonAlignTop.OnClick
        btnAlignTop_Click(Nothing)
    End Sub

    Private Sub btnAlignCenter_Click(ByVal sender As Object) Handles btnAlignCenter.Click
        DoVAlign(XldVAlignment.vaCenter)
    End Sub

    Private Sub RibbonButtonAlignCenter_OnClick(sender As System.Object, control As AddinExpress.MSO.IRibbonControl, pressed As System.Boolean) Handles RibbonButtonAlignCenter.OnClick
        btnAlignCenter_Click(Nothing)
    End Sub

    Private Sub btnAlignBottom_Click(ByVal sender As Object) Handles btnAlignBottom.Click
        DoVAlign(XldVAlignment.vaBottom)
    End Sub

    Private Sub RibbonButtonAlignBottom_OnClick(sender As System.Object, control As AddinExpress.MSO.IRibbonControl, pressed As System.Boolean) Handles RibbonButtonAlignBottom.OnClick
        btnAlignBottom_Click(Nothing)
    End Sub

    ' merge
    Private Sub btnMergeCellsTopdown_Click(ByVal sender As Object) Handles btnMergeCellsTopdown.Click
        DoMerge(XldMergeCells.mcTopDown)
    End Sub

    Private Sub RibbonButtonMergeCellsTopDown_OnClick(sender As System.Object, control As AddinExpress.MSO.IRibbonControl, pressed As System.Boolean) Handles RibbonButtonMergeCellsTopDown.OnClick
        btnMergeCellsTopdown_Click(Nothing)
    End Sub

    Private Sub btnMergeAndTop_Click(ByVal sender As Object) Handles btnMergeAndTop.Click
        DoMerge(XldMergeCells.mcTop)
    End Sub

    Private Sub RibbonButtonMergeTop_OnClick(sender As System.Object, control As AddinExpress.MSO.IRibbonControl, pressed As System.Boolean) Handles RibbonButtonMergeTop.OnClick
        btnMergeAndTop_Click(Nothing)
    End Sub

    Private Sub btnMergeAndCenter_Click(ByVal sender As Object) Handles btnMergeAndCenter.Click
        DoMerge(XldMergeCells.mcCenter)
    End Sub

    Private Sub RibbonButtonMergeCenter_OnClick(sender As System.Object, control As AddinExpress.MSO.IRibbonControl, pressed As System.Boolean) Handles RibbonButtonMergeCenter.OnClick
        btnMergeAndCenter_Click(Nothing)
    End Sub

    Private Sub btnMergeAndBottom_Click(ByVal sender As Object) Handles btnMergeAndBottom.Click
        DoMerge(XldMergeCells.mcBottom)
    End Sub

    Private Sub RibbonButtonMergeBottom_OnClick(sender As System.Object, control As AddinExpress.MSO.IRibbonControl, pressed As System.Boolean) Handles RibbonButtonMergeBottom.OnClick
        btnMergeAndBottom_Click(Nothing)
    End Sub

    ' show/hide
    Private Sub btnComments_Click(ByVal sender As Object) Handles btnComments.Click
        DoShowHide(XldShowHide.shComments)
    End Sub

    Private Sub RibbonButtonShowHideComments_OnClick(sender As System.Object, control As AddinExpress.MSO.IRibbonControl, pressed As System.Boolean) Handles RibbonButtonShowHideComments.OnClick
        btnComments_Click(Nothing)
    End Sub

    Private Sub btnZeroValues_Click(ByVal sender As Object) Handles btnZeroValues.Click
        DoShowHide(XldShowHide.shZeros)
    End Sub

    Private Sub RibbonButtonShowHideZeroValues_OnClick(sender As System.Object, control As AddinExpress.MSO.IRibbonControl, pressed As System.Boolean) Handles RibbonButtonShowHideZeroValues.OnClick
        btnZeroValues_Click(Nothing)
    End Sub

    Private Sub btnFormulas_Click(ByVal sender As Object) Handles btnFormulas.Click
        DoShowHide(XldShowHide.shFormulas)
    End Sub

    Private Sub RibbonButtonShowHideFormulas_OnClick(sender As System.Object, control As AddinExpress.MSO.IRibbonControl, pressed As System.Boolean) Handles RibbonButtonShowHideFormulas.OnClick
        btnFormulas_Click(Nothing)
    End Sub

    Private Sub btnGridlines_Click(ByVal sender As Object) Handles btnGridlines.Click
        DoShowHide(XldShowHide.shGridlines)
    End Sub

    Private Sub RibbonButtonShowHideGridlines_OnClick(sender As System.Object, control As AddinExpress.MSO.IRibbonControl, pressed As System.Boolean) Handles RibbonButtonShowHideGridlines.OnClick
        btnGridlines_Click(Nothing)
    End Sub

    Private Sub btnPageBreaks_Click(ByVal sender As Object) Handles btnPageBreaks.Click
        DoShowHide(XldShowHide.shPageBreaks)
    End Sub

    Private Sub RibbonButtonShowHidePageBreaks_OnClick(sender As System.Object, control As AddinExpress.MSO.IRibbonControl, pressed As System.Boolean) Handles RibbonButtonShowHidePageBreaks.OnClick
        btnPageBreaks_Click(Nothing)
    End Sub

    ' paste
    Private Sub btnAll_Click(ByVal sender As Object) Handles btnAll.Click
        DoPasteSpecial(Excel.XlPasteType.xlPasteAll)
    End Sub

    Private Sub RibbonButtonAll_OnClick(sender As System.Object, control As AddinExpress.MSO.IRibbonControl, pressed As System.Boolean) Handles RibbonButtonAll.OnClick
        btnAll_Click(Nothing)
    End Sub

    Private Sub btnAllExceptBorders_Click(ByVal sender As Object) Handles btnAllExceptBorders.Click
        DoPasteSpecial(Excel.XlPasteType.xlPasteAllExceptBorders)
    End Sub

    Private Sub RibbonButtonAllExceptBorders_OnClick(sender As System.Object, control As AddinExpress.MSO.IRibbonControl, pressed As System.Boolean) Handles RibbonButtonAllExceptBorders.OnClick
        btnAllExceptBorders_Click(Nothing)
    End Sub

    Private Sub btnPasteLinks_Click(ByVal sender As Object) Handles btnPasteLinks.Click
        DoPasteSpecial(xlLinks)
    End Sub

    Private Sub RibbonButtonPasteLinks_OnClick(sender As System.Object, control As AddinExpress.MSO.IRibbonControl, pressed As System.Boolean) Handles RibbonButtonPasteLinks.OnClick
        btnPasteLinks_Click(Nothing)
    End Sub

    Private Sub btnFormulas_pp_Click(ByVal sender As Object) Handles btnFormulas_pp.Click
        DoPasteSpecial(Excel.XlPasteType.xlPasteFormulas)
    End Sub

    Private Sub RibbonButtonFormulas_OnClick(sender As System.Object, control As AddinExpress.MSO.IRibbonControl, pressed As System.Boolean) Handles RibbonButtonFormulas.OnClick
        btnFormulas_pp_Click(Nothing)
    End Sub

    Private Sub btnValues_Click(ByVal sender As Object) Handles btnValues.Click
        DoPasteSpecial(Excel.XlPasteType.xlPasteValues)
    End Sub

    Private Sub RibbonButtonValues_OnClick(sender As System.Object, control As AddinExpress.MSO.IRibbonControl, pressed As System.Boolean) Handles RibbonButtonValues.OnClick
        btnValues_Click(Nothing)
    End Sub

    Private Sub btnFormats_Click(ByVal sender As Object) Handles btnFormats.Click
        DoPasteSpecial(Excel.XlPasteType.xlPasteFormats)
    End Sub

    Private Sub RibbonButtonFormats_OnClick(sender As System.Object, control As AddinExpress.MSO.IRibbonControl, pressed As System.Boolean) Handles RibbonButtonFormats.OnClick
        btnFormats_Click(Nothing)
    End Sub

    Private Sub btnComments_pp_Click(ByVal sender As Object) Handles btnComments_pp.Click
        DoPasteSpecial(Excel.XlPasteType.xlPasteComments)
    End Sub

    Private Sub RibbonButtonComments_OnClick(sender As System.Object, control As AddinExpress.MSO.IRibbonControl, pressed As System.Boolean) Handles RibbonButtonComments.OnClick
        btnComments_pp_Click(Nothing)
    End Sub

    Private Sub btnColumnWidths_Click(ByVal sender As Object) Handles btnColumnWidths.Click
        DoPasteSpecial(xlColumnWidths)
    End Sub

    Private Sub RibbonButtonColumnWidths_OnClick(sender As System.Object, control As AddinExpress.MSO.IRibbonControl, pressed As System.Boolean) Handles RibbonButtonColumnWidths.OnClick
        btnColumnWidths_Click(Nothing)
    End Sub

    Private Sub btnDataValidation_Click(ByVal sender As Object) Handles btnDataValidation.Click
        DoPasteSpecial(xlDataValidation)
    End Sub

    Private Sub RibbonButtonDataValidation_OnClick(sender As System.Object, control As AddinExpress.MSO.IRibbonControl, pressed As System.Boolean) Handles RibbonButtonDataValidation.OnClick
        btnDataValidation_Click(Nothing)
    End Sub

    Private Sub btnPasteNone_Click(ByVal sender As Object) Handles btnPasteNone.Click
        DoPastAction(sender)
    End Sub

    Private Sub RibbonButtonPasteNone_OnClick(sender As System.Object, control As AddinExpress.MSO.IRibbonControl, pressed As System.Boolean) Handles RibbonButtonPasteNone.OnClick
        DoPastAction(sender)
    End Sub

    Private Sub btnPasteAdd_Click(ByVal sender As Object) Handles btnPasteAdd.Click
        DoPastAction(sender)
    End Sub

    Private Sub RibbonButtonPasteAdd_OnClick(sender As System.Object, control As AddinExpress.MSO.IRibbonControl, pressed As System.Boolean) Handles RibbonButtonPasteAdd.OnClick
        DoPastAction(sender)
    End Sub

    Private Sub btnPasteSubtract_Click(ByVal sender As Object) Handles btnPasteSubtract.Click
        DoPastAction(sender)
    End Sub

    Private Sub RibbonButtonPasteSubtract_OnClick(sender As System.Object, control As AddinExpress.MSO.IRibbonControl, pressed As System.Boolean) Handles RibbonButtonPasteSubtract.OnClick
        DoPastAction(sender)
    End Sub

    Private Sub btnPasteMultiply_Click(ByVal sender As Object) Handles btnPasteMultiply.Click
        DoPastAction(sender)
    End Sub

    Private Sub RibbonButtonPasteMultiply_OnClick(sender As System.Object, control As AddinExpress.MSO.IRibbonControl, pressed As System.Boolean) Handles RibbonButtonPasteMultiply.OnClick
        DoPastAction(sender)
    End Sub

    Private Sub btnPasteDivide_Click(ByVal sender As Object) Handles btnPasteDivide.Click
        DoPastAction(sender)
    End Sub

    Private Sub RibbonButtonPasteDivide_OnClick(sender As System.Object, control As AddinExpress.MSO.IRibbonControl, pressed As System.Boolean) Handles RibbonButtonPasteDivide.OnClick
        DoPastAction(sender)
    End Sub

    Private Sub btnSkipBlanks_Click(ByVal sender As Object) Handles btnSkipBlanks.Click
        If (sender.State = AddinExpress.MSO.ADXMsoButtonState.adxMsoButtonUp) Then
            sender.State = AddinExpress.MSO.ADXMsoButtonState.adxMsoButtonDown
        Else
            sender.State = AddinExpress.MSO.ADXMsoButtonState.adxMsoButtonUp
        End If
    End Sub

    Private Sub RibbonButtonSkipBlanks_OnClick(sender As System.Object, control As AddinExpress.MSO.IRibbonControl, pressed As System.Boolean) Handles RibbonButtonSkipBlanks.OnClick
        '
    End Sub

    Private Sub btnTranspose_Click(ByVal sender As Object) Handles btnTranspose.Click
        If (sender.State = AddinExpress.MSO.ADXMsoButtonState.adxMsoButtonUp) Then
            sender.State = AddinExpress.MSO.ADXMsoButtonState.adxMsoButtonDown
        Else
            sender.State = AddinExpress.MSO.ADXMsoButtonState.adxMsoButtonUp
        End If
    End Sub

    Private Sub RibbonButtonTranspose_OnClick(sender As System.Object, control As AddinExpress.MSO.IRibbonControl, pressed As System.Boolean) Handles RibbonButtonTranspose.OnClick
        '
    End Sub

#End Region

#Region "Private members"

    Private Sub DoAbout()
        Dim toysVersion As String = System.Reflection.Assembly.GetExecutingAssembly().GetName().Version.ToString(3)
        Dim btn As AddinExpress.MSO.ADXRibbonButton = New AddinExpress.MSO.ADXRibbonButton()
        Dim adxVersion As String = System.Reflection.Assembly.GetAssembly(btn.GetType()).GetName().Version.ToString(3)
        Dim about As AboutForm = New AboutForm()

        about.LabelFor.Text = String.Format(about.LabelFor.Text, New Object() {"Microsoft" + Convert.ToChar(174) + " Excel"})
        about.LabelVersion.Text = String.Format(about.LabelVersion.Text, New Object() {toysVersion})
        about.LabelADXVersion.Text = String.Format(about.LabelADXVersion.Text, New Object() {adxVersion})
        about.ShowDialog()
        about.Dispose()
    End Sub

    Private Function GetSelectedRange() As Excel.Range
        Return ExcelApp.Selection
    End Function

    Private Sub DoCellFormat(ByVal format As XldCellFormat)
        Dim range As Excel.Range = GetSelectedRange()

        If range IsNot Nothing Then
            Select Case format
                Case XldCellFormat.cfWrapText
                    range.ShrinkToFit = False
                    range.WrapText = Not range.WrapText
                Case XldCellFormat.cfShrinkToFit
                    range.WrapText = False
                    range.ShrinkToFit = Not range.ShrinkToFit
                Case XldCellFormat.cfUnderlineDouble
                    Dim font As Excel.Font = range.Font
                    font.Underline = Excel.XlUnderlineStyle.xlUnderlineStyleDouble
                    Marshal.ReleaseComObject(font)
                Case XldCellFormat.cfUnderlineDoubleAccounting
                    Dim font As Excel.Font = range.Font
                    font.Underline = Excel.XlUnderlineStyle.xlUnderlineStyleDoubleAccounting
                    Marshal.ReleaseComObject(font)
                Case XldCellFormat.cfUnderlineNone
                    Dim font As Excel.Font = range.Font
                    font.Underline = Excel.XlUnderlineStyle.xlUnderlineStyleNone
                    Marshal.ReleaseComObject(font)
                Case XldCellFormat.cfUnderlineSingle
                    Dim font As Excel.Font = range.Font
                    font.Underline = Excel.XlUnderlineStyle.xlUnderlineStyleSingle
                    Marshal.ReleaseComObject(font)
                Case XldCellFormat.cfUnderlineSingleAccounting
                    Dim font As Excel.Font = range.Font
                    font.Underline = Excel.XlUnderlineStyle.xlUnderlineStyleSingleAccounting
                    Marshal.ReleaseComObject(font)
            End Select
            Marshal.ReleaseComObject(range)
        End If
    End Sub

    Private Sub DoVAlign(ByVal alignment As XldVAlignment)
        Dim range As Excel.Range = GetSelectedRange()

        If range IsNot Nothing Then
            Select Case alignment
                Case XldVAlignment.vaBottom
                    range.VerticalAlignment = Excel.XlVAlign.xlVAlignBottom
                Case XldVAlignment.vaCenter
                    range.VerticalAlignment = Excel.XlVAlign.xlVAlignCenter
                Case XldVAlignment.vaTop
                    range.VerticalAlignment = Excel.XlVAlign.xlVAlignTop
            End Select
            Marshal.ReleaseComObject(range)
        End If
    End Sub

    Private Sub DoMerge(ByVal merge As XldMergeCells)
        Dim range As Excel.Range = GetSelectedRange()

        If range IsNot Nothing Then
            If merge = XldMergeCells.mcTopDown Then
                Dim areas As Excel.Areas = range.Areas
                For j As Integer = 1 To areas.Count
                    Dim area As Excel.Range = areas(j)
                    Dim columns As Excel.Range = area.Columns
                    For i As Integer = 1 To columns.Count
                        columns(i, Type.Missing).Merge(False)
                    Next i
                    Marshal.ReleaseComObject(columns)
                    Marshal.ReleaseComObject(area)
                Next j
                Marshal.ReleaseComObject(areas)
            Else
                range.Merge(False)
            End If
            Select Case merge
                Case XldMergeCells.mcTop
                    range.VerticalAlignment = Excel.XlVAlign.xlVAlignTop
                Case XldMergeCells.mcBottom
                    range.VerticalAlignment = Excel.XlVAlign.xlVAlignBottom
                Case XldMergeCells.mcCenter
                    range.VerticalAlignment = Excel.XlVAlign.xlVAlignCenter
            End Select
            Marshal.ReleaseComObject(range)
        End If
    End Sub

    Private Sub DoShowHide(ByVal sh As XldShowHide)
        Dim ws As Excel._Worksheet = Nothing
        Dim wnd As Excel.Window = Nothing

        Select Case sh
            Case XldShowHide.shZeros
                wnd = ExcelApp.ActiveWindow
                If wnd IsNot Nothing Then
                    wnd.DisplayZeros = Not wnd.DisplayZeros
                    Marshal.ReleaseComObject(wnd)
                End If
            Case XldShowHide.shComments
                ws = ExcelApp.ActiveSheet
                If ws IsNot Nothing Then
                    Dim comments As Excel.Comments = ws.Comments
                    For i As Integer = 1 To comments.Count
                        comments(i).Visible = Not comments(i).Visible
                    Next i
                    Marshal.ReleaseComObject(comments)
                    Marshal.ReleaseComObject(ws)
                End If
            Case XldShowHide.shPageBreaks
                ws = ExcelApp.ActiveSheet
                If ws IsNot Nothing Then
                    ws.DisplayAutomaticPageBreaks = Not ws.DisplayAutomaticPageBreaks
                    Marshal.ReleaseComObject(ws)
                End If
            Case XldShowHide.shGridlines
                wnd = ExcelApp.ActiveWindow
                If wnd IsNot Nothing Then
                    wnd.DisplayGridlines = Not wnd.DisplayGridlines
                    Marshal.ReleaseComObject(wnd)
                End If
            Case XldShowHide.shFormulas
                wnd = ExcelApp.ActiveWindow
                If wnd IsNot Nothing Then
                    wnd.DisplayFormulas = Not wnd.DisplayFormulas
                    Marshal.ReleaseComObject(wnd)
                End If
        End Select
    End Sub

    Private Function ControlByTag(ByVal tag As String) As AddinExpress.MSO.ADXCommandBarButton
        For i As Integer = 0 To adxCommandBar1.Controls.Count - 1
            If adxCommandBar1.Controls(i).Tag = tag Then
                Return adxCommandBar1.Controls(i)
            End If
        Next i
        Return Nothing
    End Function

    Private Sub DoPasteSpecial(ByVal paste As Integer)
        Dim range As Excel.Range = GetSelectedRange()

        If range IsNot Nothing Then
            Dim operation As Excel.XlPasteSpecialOperation = Excel.XlPasteSpecialOperation.xlPasteSpecialOperationNone
            If Me.HostMajorVersion > 11 Then ' 9 = Excel 2000, 10 = XP, 11 = 2003, 12 = 2007 (ribbon), 14 = 2010, 15 = 2013
                ' ribbon controls
                For i As Integer = 71 To 75
                    If Me.FindRibbonControl(i).Pressed Then
                        Select Case i
                            Case 71
                                operation = Excel.XlPasteSpecialOperation.xlPasteSpecialOperationNone
                            Case 72
                                operation = Excel.XlPasteSpecialOperation.xlPasteSpecialOperationAdd
                            Case 73
                                operation = Excel.XlPasteSpecialOperation.xlPasteSpecialOperationSubtract
                            Case 74
                                operation = Excel.XlPasteSpecialOperation.xlPasteSpecialOperationMultiply
                            Case 75
                                operation = Excel.XlPasteSpecialOperation.xlPasteSpecialOperationDivide
                        End Select
                        Exit For
                    End If
                Next i
            Else
                ' command bar bontrols
                For i As Integer = 71 To 75
                    If ControlByTag(i.ToString()).State = AddinExpress.MSO.ADXMsoButtonState.adxMsoButtonDown Then
                        Select Case i
                            Case 71
                                operation = Excel.XlPasteSpecialOperation.xlPasteSpecialOperationNone
                            Case 72
                                operation = Excel.XlPasteSpecialOperation.xlPasteSpecialOperationAdd
                            Case 73
                                operation = Excel.XlPasteSpecialOperation.xlPasteSpecialOperationSubtract
                            Case 74
                                operation = Excel.XlPasteSpecialOperation.xlPasteSpecialOperationMultiply
                            Case 75
                                operation = Excel.XlPasteSpecialOperation.xlPasteSpecialOperationDivide
                        End Select
                        Exit For
                    End If
                Next i
            End If

            Dim skipBlanks As Boolean
            Dim transpose As Boolean
            If Me.HostMajorVersion > 11 Then ' 9 = Excel 2000, 10 = XP, 11 = 2003, 12 = 2007 (ribbon), 14 = 2010, 15 = 2013
                ' ribbon controls
                skipBlanks = Me.FindRibbonControl(76).Pressed
                transpose = Me.FindRibbonControl(77).Pressed
            Else
                ' command bar bontrols
                skipBlanks = (ControlByTag("76").State = AddinExpress.MSO.ADXMsoButtonState.adxMsoButtonDown)
                transpose = (ControlByTag("77").State = AddinExpress.MSO.ADXMsoButtonState.adxMsoButtonDown)
            End If
            Select Case paste
                Case xlLinks
                    Dim objParent As Object = range.Parent
                    If TypeOf objParent Is Excel._Worksheet Then
                        objParent.Paste(Type.Missing, True)
                    End If
                    Marshal.ReleaseComObject(objParent)
                Case Else
                    range.PasteSpecial(paste, operation, skipBlanks, transpose)
            End Select
            range = Nothing
        End If
    End Sub

    Private Sub DoPastAction(ByVal sender As Object)
        If TypeOf sender Is AddinExpress.MSO.ADXCommandBarButton Then
            If sender.State = AddinExpress.MSO.ADXMsoButtonState.adxMsoButtonUp Then
                For i As Integer = 13 To 17
                    If i <> adxCommandBar1.Controls.IndexOf(sender) Then
                        CType(adxCommandBar1.Controls(i), AddinExpress.MSO.ADXCommandBarButton).State = AddinExpress.MSO.ADXMsoButtonState.adxMsoButtonUp
                    End If
                Next i
                sender.State = AddinExpress.MSO.ADXMsoButtonState.adxMsoButtonDown
            End If
        ElseIf TypeOf sender Is AddinExpress.MSO.ADXRibbonButton Then
            If sender.Pressed Then
                For i As Integer = 3 To 7
                    If RibbonButtonGroup2.Controls(i) IsNot sender Then
                        RibbonButtonGroup2.Controls(i).AsRibbonButton.Pressed = False
                    End If
                Next i
            Else
                RibbonButtonPasteNone.Pressed = True
            End If
        End If
    End Sub

#End Region
End Class

